<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 15/02/2018
 * Time: 15:32
 */

namespace App\Controller\Rest;
use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use App\Entity\Bibliotheque_ingredients;
use App\Entity\Ingredients;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Validator\Constraints\DateTime;
/**
 * @Route("/api")
 */

class BibliothequeIngredientsController  extends FOSRestController
{

    /**
     * @Rest\Post("/bibliothequeingredients")
     */
    public function addAction(Request $request)
    {
        $data=$request->request->all();
        $ingredient = new Bibliotheque_ingredients();
        if ($this->isValid($data)) {
            $ingredient->setNOM($data['NOM']);
            $ingredient->setDESCRIPTION($data['DESCRIPTION']);
            $ingredient->setPRIXSUGGERE($data['PRIXSUGGERE']);
            $ingredient->setACTIF($data['ACTIF']);
            $em = $this->getDoctrine()->getManager();
            $em->persist($ingredient);
            $Categorie= $em->getRepository('App:Categorie')->find(intval($data['CATEGORIE']));
            $ingredient->setCATEGORIE($Categorie);
            $em->flush();
            $id = $ingredient->getId();
            return new JsonResponse([
                'id'=>$id,
                'success' => true,
                'code'    => 200
            ]);
        }
        else {
            $response = new Response();
            $response->setStatusCode(400);
            return $response;
        }
    }

    /**
     * @Rest\Post("/bibliothequeingredients/newCarteIngredient")
     */
    public function setNewCarteIngredient(Request $request)
    {
        $Alldata=$request->request->all();
        $em = $this->getDoctrine()->getManager();
        $cnt = 0;
        foreach ($Alldata['ingredients'] as $key => $data) {
            $ingredient = new Ingredients();
            $ing = $em->getRepository('App:Bibliotheque_ingredients')->find($data);
            $ingredient->setNOM($ing->getNOM());
            $ingredient->setDESCRIPTION($ing->getDESCRIPTION());
            $ingredient->setPRIX($ing->getPRIXSUGGERE());
            $date = new \DateTime();
            $ingredient->setDISPONIBLE('1');
            $ingredient->setACTIF($ing->getACTIF());
            $ip = $request->getClientIp();
            $ingredient->setIPADRESSENR($ip);
            $ingredient->setDATEENR($date);
            $date2=new \DateTime(null);
            $ingredient->setDATELASTMOD($date2);
            $ingredient->setUSERENR('0');
            $ingredient->setIPADRESSLASTMOD('');
            $ingredient->setUSERLASTMOD('0');
            $carte= $em->getRepository('App:Carte')->find(intval($Alldata['carte']));
            $ingredient->setCARTE($carte);
            $ingredient->setINGREDIENTCATEGORIE($ing->getINGREDIENTCATEGORIE());
            $em->persist($ingredient);
            $cnt ++;

            var_dump($cnt);
        }
        $em->flush();
        return new JsonResponse([
            'success' => true,
            'code'    => 200
        ]);
        /*else {
            $response = new Response();
            $response->setStatusCode(400);
            return $response;
        }*/
    }



    /**
     * @Rest\Get("/bibliothequeingredients")
     */
    public function getListAction()
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ingredients=$qb->select("i.id,i.PRIXSUGGERE,i.NOM,C.NOM as CATEGORIE")
            ->from("App:Bibliotheque_ingredients", "i")
            ->innerJoin('i.INGREDIENT_CATEGORIE','C')
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($ingredients, 'json');
        $response = new Response();
        $response->setContent($data);
        return new JsonResponse(json_decode($data));

    }

    /**
     * @Rest\Get("/ingredients/carte/{idCarte}")
     */
/*    public function getListIngCarteAction($idCarte)
    {

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ingredients=$qb->select("i.id,i.PRIX,i.ACTIF,i.DESCRIPTION,i.DISPONIBLE,i.NOM,C.id as CARTE,IC.id as idCAT,IC.NOM as CATEGORIE")
            ->from("App:Ingredients", "i")
            ->innerJoin('i.CARTE','C')
            ->innerJoin('i.INGREDIENT_CATEGORIE','IC')
            ->where('C.id LIKE :carte')
            ->setParameter('carte', $idCarte)
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($ingredients, 'json');
        $response = new Response();
        $response->setContent($data);
        return new JsonResponse(json_decode($data));

    }*/

    /**
     * @Rest\Delete("/bibliothequeingredients/{id}")
     */
    public function deleteAction($id)
    {
        $em = $this->getDoctrine()->getManager();
        $p = $em->getRepository('App:Bibliotheque_ingredients')->find($id);
        $em->remove($p);
        $em->flush();
        return new JsonResponse([
            'success' => true,
            'code'    => 200
        ]);
    }

    /**
     * @Rest\Put("/bibliothequeingredients/{id}")
     */
    public function updateAction(Request $request,$id)
    {
        $data=$request->request->all();
        $ingredient = $this->getDoctrine()->getRepository("App:Bibliotheque_ingredients")->find($id);
        if ($this->isValid($data)) {
            $ingredient->setNOM($data['NOM']);
            $ingredient->setDESCRIPTION($data['DESCRIPTION']);
            $ingredient->setPRIXSUGGERE($data['PRIXSUGGERE']);
            $ingredient->setACTIF($data['ACTIF']);
            $em = $this->getDoctrine()->getManager();
            $em->persist($ingredient);
            $Categorie= $em->getRepository('App:Categorie')->find(intval($data['CATEGORIE']));
            $ingredient->setCATEGORIE($Categorie);
            $em->flush();
            return new JsonResponse([
                'success' => true,
                'code'    => 200
            ]);
        }
        else {
            $response = new Response();
            $response->setStatusCode(400);
            return $response;
        }
    }


    public function isValid($data)
    {
        return array_key_exists('NOM', $data) && trim($data['NOM'])!='';
    }

    /**
     * @return string
     */
    private function generateUniqueFileName()
    {
        // md5() reduces the similarity of the file names generated by
        // uniqid(), which is based on timestamps
        return md5(uniqid());
    }

}
