<?php

namespace App\Controller\Rest;
ini_set('MAX_EXECUTION_TIME', -1);
set_time_limit(99999999999);

use App\Entity\Command;
use App\Entity\CommandElement;
use App\Entity\CommandElementIngredients;
use App\Entity\CommandMenu;
use App\Entity\CommandPaymentMode;
use App\Entity\Customer;
use App\Entity\CustomerPdv;
use App\Entity\Address;

use Doctrine\ORM\EntityManagerInterface;
use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Request\ParamFetcher;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;


class ImportOrdersController extends FOSRestController
{
    private $em;
    private $mysqli;

    public function __construct(EntityManagerInterface $em)
    {
       $this->mysqli = new \mysqli("51.68.40.207", "root", "KkqJv6FkkZ", "restocall");
       $this->mysqli->set_charset('utf8');
       $this->em = $em;
    }

    /**
     * @Rest\Get("/importOrders")
     */
    public function import()
    {
        //$this->importClients();
        //$this->updateCommands();
        //$this->importCommands();
        $this->setOrder();
        return new JsonResponse([], 200);
    }

    private function setOrder()
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $pdvs = $qb->select("DISTINCT(p.id)")
            ->from("App:Command", "c")
            ->innerJoin("c.orderTypePdv", "ot")
            ->innerJoin("ot.pdv", "p")
            ->where("c.createdAt like :createdAt")
            ->setParameter('createdAt', '%2019-06-01%')
            ->getQuery()
            ->getResult();
        foreach ($pdvs as $pdv) {
            $qb = $em->createQueryBuilder();
            $orders = $qb->select("c")
            ->from("App:Command", "c")
            ->innerJoin("c.orderTypePdv", "ot")
            ->innerJoin("ot.pdv", "p")
            ->where("c.createdAt like :createdAt")
            ->andWhere("p.id=:pdv")
            ->setParameter('createdAt', '%2019-06-01%')
            ->setParameter('pdv', $pdv)
            ->orderBy('c.createdAt','ASC')
            ->getQuery()
            ->getResult();
            foreach ($orders as $index => $order) {
                $num=intval($index)+1;
                $order->setNum($num);
                $em->persist($order);
                $em->flush();
            }
        }
    }

    private function importClients()
    {
        $query = "SELECT * FROM `customer` WHERE `created_at` LIKE '%2019-06-01%'";
        $statement = $this->mysqli->query($query);
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $this->importCustomer($row);
            }
        }
        $this->em->flush();
    }

    private function importCustomer($row)
    {
            // $customer = new Customer();
            // $customer->setFirstname($row['firstname']);
            // $customer->setLastname($row['lastname']);
            // $customer->setSociety($row['society']);
            // $customer->setPhone($row['phone']);
            // $customer->setSecondaryPhone($row['secondaryPhone']);
            // $customer->setEmail($row['email']);
            // $customer->setSmsAuthorized($row['smsAuthorized']);
            // $customer->setCreatedIp($row['createdIp']);
            // $customer->setUpdatedIp($row['updatedIp']);
            // $customer->setCreatedUser(null);
            // $customer->setUpdatedUser(null);
            // $customer->setCreatedAt($row['createdAt']);
            // $customer->setUpdatedAt($row['updatedAt']);
            // $customer->setIndicator($row['indicator']);
            // $this->em->persist($customer);
            $em = $this->getDoctrine()->getManager();
            $qb = $em->createQueryBuilder();
            $customer = $qb->select("c")
            ->from("App:Customer", "c")
            ->where("c.phone = :phone")
            ->andWhere('c.createdAt like :createdAt')
            ->setParameter('createdAt', "%2019-06-01%")
            ->setParameter('phone',$row['phone'])
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
             $query1 = "select * from pdv_customer where customer_id=".$row['id'];
             $statement1 = $this->mysqli->query($query1);
             if ($statement1->num_rows > 0) {
                 while ($row1 = $statement1->fetch_assoc()) {
                     $this->importCustomerPdv($customer,$row1);
                 }
             }   
    }

    private function importCustomerPdv($customer,$row){
            $pdv = $this->getDoctrine()->getRepository("App:Pdv")->find($row['pdv_id']);
            $customerPdv = $this->getDoctrine()->getRepository("App:CustomerPdv")->findOneBy(
                array(
                    'customer'=>$customer,
                    'pdv'=>$pdv
                )
            );
            if(!$customerPdv){
                $customer->getId()."_";
            }
            // $customerPdv = new CustomerPdv();
            // $customerPdv->setcustomer($customer);
            // $pdv = $this->getDoctrine()->getRepository("App:Pdv")->find($row['pdv_id']);
            // $customerPdv->setPdv($pdv);
            // $customerPdv->setComment($row['comment']);
            // $this->em->persist($customerPdv);
            // $query2 = "select * from address where customer_id=".$row['id'];
            // $statement2 = $this->mysqli->query($query2);
            // if ($statement2->num_rows > 0) {
            //     while ($row2 = $statement2->fetch_assoc()) {
            //         $this->importAddress($customerPdv,$row2);
            //     }
            // }

    }

    private function importAddress($customerPdv,$row){
            $address = new Address();
            $address->setPrincipal(1);
            $address->setStreetName($row['street_name']);
            $address->setStreetNumber($row['street_number']);
            $address->setPostalCode($row['postalCode']);
            $address->setCity($row['city']);
            $address->setComplementAddress($row['complement_address']);
            $address->setInputCode($row['inputCode']);
            $address->setBuilding($row['building']);
            $address->setStaircase($row['staircase']);
            $address->setFloor($row['floor']);
            $address->setIntercom($row['intercom']);
            $address->setDoor($row['door']);
            $address->setCountry($row['country']);
            $address->setActive(1);
            $address->setCustomer($customerPdv);
            $this->em->persist($address);
    }

    private function importCommands()
    {
        //$query = "select * from commandes where  IDENTIFIANT_PDV=" . $this->idPdv;
        $query = 'select * from command where `createdAt` like "%2019-06-01%"';
        $statement = $this->mysqli->query($query);
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $this->importCommmand($row);
            }
        }
    }

    private function updateCommands()
    {
        //$query = "select * from commandes where  IDENTIFIANT_PDV=" . $this->idPdv;
        $query = 'select c.id,c.createdAt,c.amount,cu.phone,pc.comment,cu.indicator,a.id as idAddress,a.street_number as address,pc.pdv_id as pdv from customer cu,pdv_customer pc,command c left join address a on a.id=c.address_id where c.customer_id=pc.id and pc.customer_id=cu.id and c.`createdAt` like "%2019-06-01%"';
        $statement = $this->mysqli->query($query);
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $this->updateCommmand($row);
            }
        }
    }

    private function updateCommmand($row){
         $em = $this->getDoctrine()->getManager();
         $qb2 = $em->createQueryBuilder();
         $order = $qb2->select("c")
            ->from("App:Command", "c")
            ->where("c.createdAt = :createdAt")
            ->andWhere('c.amount = :amount')
            ->setParameter('createdAt', $row['createdAt'])
            ->setParameter('amount',$row['amount'])
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
         $qb = $em->createQueryBuilder();
        $customer = $qb->select("c")
            ->from("App:Customer", "c")
            ->where("c.phone = :phone")
            ->setParameter('phone',$row['phone'])
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $address=null;
        if(is_null($customer)){
                echo $row['phone']."_";
        }else{
            $pdv = $this->getDoctrine()->getRepository("App:Pdv")->find($row['pdv']);
            $customerPdv = $this->getDoctrine()->getRepository("App:CustomerPdv")->findOneBy(
                array(
                    'customer'=>$customer,
                    'pdv'=>$pdv
                )
            );
            if(is_null($customerPdv)){
                $customerPdv = new CustomerPdv();
                $customerPdv->setcustomer($customer);
                $customerPdv->setPdv($pdv);
                $customerPdv->setComment($row['comment']);
                $em->persist($customerPdv);
                $em->flush();
                if($row['idAddress']){
                    $query2 = "select * from address where id=".$row['idAddress'];
                    $statement2 = $this->mysqli->query($query2);
                    if ($statement2->num_rows > 0) {
                     while ($row2 = $statement2->fetch_assoc()) {
                        $address = new Address();
                        $address->setPrincipal(1);
                        $address->setStreetName($row2['street_name']);
                        $address->setStreetNumber($row2['street_number']);
                        $address->setPostalCode($row2['postal_code']);
                        $address->setCity($row2['city']);
                        $address->setComplementAddress($row2['complement_address']);
                        $address->setInputCode($row2['input_code']);
                        $address->setBuilding($row2['building']);
                        $address->setStaircase($row2['staircase']);
                        $address->setFloor($row2['floor']);
                        $address->setIntercom($row2['intercom']);
                        $address->setDoor($row2['door']);
                        $address->setCountry($row2['country']);
                        $address->setActive(1);
                        $address->setCustomer($customerPdv);
                        $em->persist($address);
                        $em->flush();
                        $order->setAddress($address);
                     }
                    }
                }
            }else{
                if($row['idAddress']){
                    $address = $this->getDoctrine()->getRepository("App:Address")->findOneBy(
                        array(
                            'customer'=>$customerPdv
                        )
                    );
                    $order->setAddress($address);
                }
            }
        }
        $order->setCustomer($customerPdv);
        $em->persist($order);
        $em->flush();
    }

    private function importCommmand($row)
    {
        $idOld=$row['id'];
        $em = $this->getDoctrine()->getManager();
        $qb5 = $em->createQueryBuilder();
        $order = $qb5->select("c")
            ->from("App:Command", "c")
            ->where("c.createdAt = :createdAt")
            ->andWhere('c.amount = :amount')
            ->setParameter('createdAt', $row['createdAt'])
            ->setParameter('amount',$row['amount'])
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $query1 = "select * from command_element where command_menu_id IS NULL AND  command_id=" . $idOld;
        $statement1 = $this->mysqli->query($query1);
        if ($statement1->num_rows > 0) {
            while ($row1 = $statement1->fetch_assoc()) {
                $commandElement = new CommandElement();
                $commandElement->setName($row1['name']);
                $commandElement->setQuantity($row1['quantity']);
                $commandElement->setComment($row1['comment']);
                $commandElement->setTotal($row1['total']);
                $commandElement->setPrice($row1['price']);
                $commandElement->setVat($row1['vat']);
                $commandElement->setSize($row1['size']);
                $commandElement->setLevel($row1['level']);
                $commandElement->setAdditionalCost($row1['additionalCost']);
                $commandElement->setCommand($order);
                $commandElement->setCode($row1['code']);
                $this->em->persist($commandElement);
                $query2 = "select * from command_element_ingredients where command_element_id=" . $row1['id'];
                $statement2 = $this->mysqli->query($query2);
                if ($statement2->num_rows > 0) {
                    while ($row2 = $statement2->fetch_assoc()) {
                        $commandElementIng = new CommandElementIngredients();
                        $commandElementIng->setName($row2['name']);
                        $commandElementIng->setCout($row2['cout']);
                        $commandElementIng->setAction($row2['action']);
                        $commandElementIng->setCommandElement($commandElement);
                        $this->em->persist($commandElementIng);
                    }
                }
            }
        }
        $query3 = "select * from command_menu where  command_id=" . $idOld;
        $statement3 = $this->mysqli->query($query3);
        if ($statement3->num_rows > 0) {
            while ($row3 = $statement3->fetch_assoc()) {
                $commandMenu = new CommandMenu();
                $commandMenu->setTitle($row3['title']);
                $commandMenu->setQuantity($row3['quantity']);
                $commandMenu->setComment($row3['comment']);
                $commandMenu->setTotal($row3['total']);
                $commandMenu->setPrice($row3['price']);
                $commandMenu->setVat($row3['vat']);
                $commandMenu->setAdditionalCost($row3['additionalCost']);
                $commandMenu->setCommand($order);
                $commandMenu->setCode($row3['code']);
                $commandMenu->setMenu(null);
                $this->em->persist($commandMenu);
                $query4 = "select * from command_element where  command_id='" . $idOld . "'AND command_menu_id =" . $row3['id'];
                $statement4 = $this->mysqli->query($query4);
                if ($statement4->num_rows > 0) {
                    while ($row4 = $statement4->fetch_assoc()) {
                        $commandElement = new CommandElement();
                        $commandElement->setName($row4['name']);
                        $commandElement->setQuantity($row4['quantity']);
                        $commandElement->setComment($row4['comment']);
                        $commandElement->setTotal($row4['total']);
                        $commandElement->setPrice($row4['price']);
                        $commandElement->setVat($row4['vat']);
                        $commandElement->setSize($row4['size']);
                        $commandElement->setLevel($row4['level']);
                        $commandElement->setAdditionalCost($row4['additionalCost']);
                        $commandElement->setCommand($order);
                        $commandElement->setCode($row4['code']);
                        $this->em->persist($commandElement);
                        $query5 = "select * from command_element_ingredients where command_element_id=" . $row4['id'];
                        $statement5 = $this->mysqli->query($query5);
                        if ($statement5->num_rows > 0) {
                            while ($row5 = $statement5->fetch_assoc()) {
                                $commandElementIng = new CommandElementIngredients();
                                $commandElementIng->setName($row5['name']);
                                $commandElementIng->setCout($row5['cout']);
                                $commandElementIng->setAction($row5['action']);
                                $commandElementIng->setCommandElement($commandElement);
                                $this->em->persist($commandElementIng);
                            }
                        }
                    }
                }
            }
        }
        $query6 = "select * from command_payment_mode where command_id=" . $idOld;
                        $statement6 = $this->mysqli->query($query6);
                        if ($statement6->num_rows > 0) {
                            while ($row6 = $statement6->fetch_assoc()) {
                                $payementMode = $this->em->getRepository('App:PaymentMode')->find($row6['payment_mode_id']);
                                $commandPaymentMode = new CommandPaymentMode();
                                if ($payementMode) {
                                    $commandPaymentMode->setPaymentMode($payementMode);
                                    $commandPaymentMode->setCommand($order);
                                    $commandPaymentMode->setAmount($row6['amount']);
                                    $this->em->persist($commandPaymentMode);
                                }
                            }
                        }
        $this->em->persist($order);
        $this->em->flush();
    }
}