<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 23/02/2018
 * Time: 15:51
 */

namespace App\Controller\Rest;


use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Request\ParamFetcher;
use App\Entity\Ingredient_catfamtaille;
use App\Entity\IngredientCatFamSize;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Controller\Annotations\RequestParam;

class IngredientCatFamSizeController extends FOSRestController
{
    /**
     * @Rest\Post("/ingredientsCatFamSize")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="ingredientsCatFamSize", nullable=false,allowBlank=false,strict=true)
     */
    public function addIngredientCatFamSize(ParamFetcher $paramFetcher)
    {
        $em = $this->getDoctrine()->getManager();
        $ingredientsCatFamSize = $paramFetcher->get('ingredientsCatFamSize');
        $tab = [];
        foreach ($ingredientsCatFamSize as $ing) {
            $cardFamily = null;
            $size = null;
            if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
                $card = $em->getRepository('App:Card')->find($this->getUser()->getPdv());
                $cardFamily = $em->getRepository('App:CardFamily')->findOneBy(array('id' => $ing['family'], 'card' => $card));
                $size = $em->getRepository('App:Size')->find(array('id' => $ing['size'], 'card' => $card));
            } else {
                $cardFamily = $em->getRepository('App:CardFamily')->find($ing['family']);
                $size = $em->getRepository('App:Size')->find($ing['size']);
            }
            if (is_null($cardFamily) || is_null($size)) {
                return new JsonResponse(null, 403);
            }
            $ingredientsCategory = $em->getRepository('App:IngredientCategory')->find($ing['ingredientCategory']);
            $ingredientCatFamSize = $em->getRepository('App:IngredientCatFamSize')->findOneBy(array('cardFamily' => $cardFamily, 'ingredientCategory' => $ingredientsCategory, 'size' => $size));
            if (is_null($ingredientCatFamSize)) {
                $ingredientCatFamSize = new IngredientCatFamSize();
                $ingredientCatFamSize->setCardFamily($cardFamily);
                $ingredientCatFamSize->setIngredientCategory($ingredientsCategory);
                $ingredientCatFamSize->setSize($size);
            }
            $ingredientCatFamSize->setPrice($ing['price']);
            $em->persist($ingredientCatFamSize);

            $tab[] = $ingredientCatFamSize;
        }

        $em->flush();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($tab, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/ingredientsCatFamSize/carte/{idCarte}")
     */
    public function getIngredientsCatFamSize($idCarte)
    {
        if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
            if ($this->getUser()->getPdv() != $idCarte) {
                return new JsonResponse(null, 403);
            }
        }
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ingredientsCategory = $qb->select("ic.id,c.name AS category,f.label AS family,s.label AS size,ic.price AS price")
            ->from("App:IngredientCatFamSize", "ic")
            ->innerJoin('ic.cardFamily', 'cf')
            ->innerJoin('cf.family', 'f')
            ->innerJoin('ic.ingredientCategory', 'c')
            ->innerJoin('ic.size', 's')
            ->innerJoin('s.card', 'C')
            ->where('C.id = :card')
            ->setParameter('card', $idCarte)
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($ingredientsCategory, 'json');
        return new JsonResponse(json_decode($data));
    }


    /**
     * @Rest\Get("/ingredientsCatFamSize/carte/{idCarte}/category/{idCategory}/family/{idFamily}")
     */
    public function getSizeOfCarteByFamily($idCarte, $idCategory, $idFamily)
    {
        // if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
        //     if ($this->getUser()->getPdv() != $idCarte) {
        //         return new JsonResponse(null, 403);
        //     }
        // }
        // $em = $this->getDoctrine()->getManager();
        // $qb = $em->createQueryBuilder();
        // $sizes = $qb->select("t.id,t.label,icf.price AS price")
        //     ->from("App:IngredientCatFamSize", "icf")
        //     ->innerJoin('icf.cardFamily', 'cf')
        //     ->innerJoin('icf.size', 't')
        //     ->innerJoin('icf.ingredientCategory', 'ic')
        //     ->innerJoin('t.card', 'C')
        //     ->where('C.id = :card')
        //     ->andWhere('cf.id = :idCardFamily')
        //     ->andWhere('ic.id = :category')
        //     ->setParameter('category', $idCategory)
        //     ->setParameter('card', $idCarte)
        //     ->setParameter('idCardFamily', $idFamily)
        //     ->getQuery()->getResult();
        // if (count($sizes) == 0) {
        //     $qb = $em->createQueryBuilder();
        //     $sizes = $qb->select("t.id,t.label")
        //         ->from("App:Size", "t")
        //         ->leftJoin('t.families', 'F')
        //         ->innerJoin('t.card', 'C')
        //         ->where('C.id = :card')
        //         ->andWhere('F.id = :family')
        //         ->setParameter('card', $idCarte)
        //         ->setParameter('family', $idFamily)
        //         ->getQuery()->getResult();
        // }
        // $serializer = $this->get('serializer');
        // $data = $serializer->serialize($sizes, 'json');
        // return new JsonResponse(json_decode($data));
        if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
            if ($this->getUser()->getPdv() != $idCarte) {
                return new JsonResponse(null, 403);
            }
        }
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $sizes1 = $qb->select("t.id,t.label,icf.price AS price")
            ->from("App:IngredientCatFamSize", "icf")
            ->innerJoin('icf.cardFamily', 'cf')
            ->innerJoin('icf.size', 't')
            ->innerJoin('icf.ingredientCategory', 'ic')
            ->innerJoin('t.card', 'C')
            ->where('C.id = :card')
            ->andWhere('cf.id = :idCardFamily')
            ->andWhere('ic.id = :category')
            ->setParameter('category', $idCategory)
            ->setParameter('card', $idCarte)
            ->setParameter('idCardFamily', $idFamily)
            ->getQuery()->getResult();
        if (count($sizes1) == 0) {
            $qb = $em->createQueryBuilder();
            $sizes = $qb->select("t.id,t.label")
                ->from("App:Size", "t")
                ->leftJoin('t.families', 'F')
                ->innerJoin('t.card', 'C')
                ->where('C.id = :card')
                ->andWhere('F.id = :family')
                ->setParameter('card', $idCarte)
                ->setParameter('family', $idFamily)
                ->getQuery()->getResult();
        }else{
        	$qb = $em->createQueryBuilder();
            $ids = array_column($sizes1, 'id');
            $sizes2 = $qb->select("t.id,t.label")
                ->from("App:Size", "t")
                ->leftJoin('t.families', 'F')
                ->innerJoin('t.card', 'C')
                ->where('C.id = :card')
                ->andWhere('F.id = :family')
                ->andWhere('t.id not in (:ids)')
                ->setParameter('card', $idCarte)
                ->setParameter('family', $idFamily)
                ->setParameter('ids', $ids)
                ->getQuery()->getResult();
            $sizes=array_merge($sizes1, $sizes2);       
        }
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($sizes, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/ingredientsCatFamSize/category/{idCategory}/family/{idFamily}/size/{idSize}")
     */
    public function getIngredientsCatFamSizeBySize($idCategory, $idFamily, $idSize)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $sizes = $qb->select("icf.id,icf.price AS price")
            ->from("App:IngredientCatFamSize", "icf")
            ->innerJoin('icf.cardFamily', 'cf')
            ->innerJoin('icf.size', 't')
            ->innerJoin('icf.ingredientCategory', 'ic')
            ->where('cf.id = :idCardFamily')
            ->andWhere('ic.id = :category')
            ->andWhere('t.id =:size');
        if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
            $sizes = $sizes->innerJoin('cf.card', 'c')
                ->andWhere('c.id = :card')
                ->setParameter('card', $this->getUser()->getPdv());
        }
        $sizes = $sizes->setParameter('category', $idCategory)
            ->setParameter('size', $idSize)
            ->setParameter('idCardFamily', $idFamily)
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($sizes, 'json');
        return new JsonResponse(json_decode($data));
    }
}