<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 15/02/2018
 * Time: 18:18
 */

namespace App\Controller\Rest;


use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Request\ParamFetcher;
use FOS\RestBundle\Controller\Annotations\RequestParam;
use App\Entity\IngredientCategory;
use App\Entity\Ingredients_categorie;
use App\Entity\Taille;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Validator\Constraints\DateTime;

class IngredientCategoryController extends FOSRestController
{
    /**
     * @Rest\Post("/ingredientcategories")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="name", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="active", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="description", nullable=true,allowBlank=true,strict=true)
     */
    public function addAction(ParamFetcher $paramFetcher)
    {
        $ingredientCategory = new IngredientCategory();
        $ingredientCategory->setName($paramFetcher->get('name'));
        $ingredientCategory->setActive($paramFetcher->get('active'));
        $ingredientCategory->setDescription($paramFetcher->get('description'));
        $em = $this->getDoctrine()->getManager();
        $em->persist($ingredientCategory);
        $em->flush();
        return new JsonResponse([
            'id'=>$ingredientCategory->getId(),
            'success' => true,
            'code' => 200
        ]);
    }

    /**
     * @Rest\Get("/ingredientcategories")
     */
    public function getListAction()
    {
        $ingredientcategorie = $this->getDoctrine()->getRepository("App:IngredientCategory")->findAll();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($ingredientcategorie, 'json');
        $response = new Response();
        $response->setContent($data);
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/ingredientcategories/{id}")
     */
    public function getById($id)
    {
        $em = $this->getDoctrine()->getManager();
        $p = $em->getRepository('App:IngredientCategory')->find($id);
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($p, 'json');
        $response = new Response();
        $response->setContent($data);
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Delete("/ingredientcategories/{id}")
     */
    public function deleteAction($id)
    {
        $em = $this->getDoctrine()->getManager();
        $p = $em->getRepository('App:IngredientCategory')->find($id);
        $em->remove($p);
        $em->flush();
        return new JsonResponse([
            'success' => true,
            'code' => 200
        ]);
    }

    /**
     * @Rest\Put("/ingredientcategorie/{id}")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="name", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="active", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="description", nullable=true,allowBlank=true,strict=true)
     */
    public function updateAction(Request $request, $id, ParamFetcher $paramFetcher)
    {
        $ingredientCategory = $this->getDoctrine()->getRepository("App:IngredientCategory")->find($id);
        $ingredientCategory->setName($paramFetcher->get('name'));
        $ingredientCategory->setActive($paramFetcher->get('active'));
        $ingredientCategory->setDescription($paramFetcher->get('description'));
        $em = $this->getDoctrine()->getManager();
        $em->persist($ingredientCategory);
        $em->flush();
        return new JsonResponse([]);
    }
}
