<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 15/02/2018
 * Time: 18:18
 */

namespace App\Controller\Rest;


use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Request\ParamFetcher;
use FOS\RestBundle\Controller\Annotations\RequestParam;
use App\Entity\MenuCategory;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Validator\Constraints\DateTime;

class MenuCategoryController  extends FOSRestController
{
    /**
     * @Rest\Post("/menucategories")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="name", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="active", nullable=false,allowBlank=false,strict=true)
     *
     */
    public function addAction( ParamFetcher $paramFetcher)
    {
        $menucategorie = new MenuCategory();
            $menucategorie->setName($paramFetcher->get('name'));
            $menucategorie->setActive($paramFetcher->get('active'));
            $em = $this->getDoctrine()->getManager();
            $em->persist($menucategorie);
            $em->flush();
            return new JsonResponse([
                'id'=> $menucategorie->getId(),
                'success' => true,
                'code'    => 200
            ]);
    }

    /**
     * @Rest\Get("/menucategories")
     */
    public function getListAction()
    {
        $menucategory = $this->getDoctrine()->getRepository("App:MenuCategory")->findAll();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($menucategory, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Delete("/menucategories/{id}")
     */
    public function deleteAction($id)
    {
        $em = $this->getDoctrine()->getManager();
        $p = $em->getRepository('App:MenuCategory')->find($id);
        $em->remove($p);
        $em->flush();
        return new JsonResponse([
            'success' => true,
            'code'    => 200
        ]);
    }

    /**
     * @Rest\Get("/menucategories/{id}")
     */
    public function getById($id)
    {
        $em = $this->getDoctrine()->getManager();
        $menucategory = $em->getRepository('App:MenuCategory')->find($id);
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($menucategory, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Put("/menucategories/{id}")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="name", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="active", nullable=true,allowBlank=true,strict=true)
     */
    public function updateAction(ParamFetcher $paramFetcher,$id)
    {
        $menucategorie = $this->getDoctrine()->getRepository("App:MenuCategory")->find($id);
            $menucategorie->setName($paramFetcher->get('name'));
            $menucategorie->setActive($paramFetcher->get('active'));
            $em = $this->getDoctrine()->getManager();
            $em->persist($menucategorie);
            $em->flush();
            return new JsonResponse([
                'success' => true,
                'code'    => 200
            ]);
    }

    /**
     * @Rest\Get("/menucategories/cmd/carte/{idCarte}")
     */
    public function getMenuCategoriesByPdv($idCarte)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder('c');
        $elements = $qb->select("c.name,c.id")
            ->from("App:Menu", "m")
            ->innerJoin('m.menuCategory', 'c')
            ->innerJoin('m.card', 'ca')
            ->where('ca.id = :card')
            ->setParameter('card', $idCarte)
            ->groupBy('c.id')
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($elements, 'json');
        return new JsonResponse(json_decode($data));
    }
}
