<?php

namespace App\Controller\Rest;

use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use Symfony\Component\HttpFoundation\JsonResponse;
use App\Entity\Pdv;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Validator\Constraints\DateTime;
class PaymentModeController extends FOSRestController
{

    /**
     * @Rest\Get("/paymentmodes")
     */
    public function getPaymentModeAction(Request $request)
    {
        $modesPaimenents = $this->getDoctrine()->getRepository("App:PaymentMode")->findAll();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($modesPaimenents, 'json');
        $response = new Response();
        $response->setContent($data);
        return new JsonResponse(json_decode($data));
    }


    /**
     * @Rest\Get("/paymentmodes/pdv/{idPdv}")
     */
    public function getPaymentModeByPdv($idPdv)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $modesPaimenents = $qb->select("pm.id, pm.label as text")
            ->from("App:Pdv", "p")
            ->innerJoin('p.paymentModes', 'pm')
            ->where('p.id = :pdv')
            ->setParameter('pdv', $idPdv)
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($modesPaimenents, 'json');
        return new JsonResponse(json_decode($data));
    }

}
