<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 18/06/2018
 * Time: 10:59
 */

namespace App\Controller\Rest;

use App\Entity\Reservation;
use App\Entity\Reservetion;
use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Request\ParamFetcher;
use FOS\RestBundle\Controller\Annotations\RequestParam;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

class ReservationController extends FOSRestController
{

    /**
     * @Rest\Post("/reservations")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="dateHour", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="tables", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="pdv", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="nbrPerson", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="comment", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="customer", nullable=true,allowBlank=true,strict=true)
     */
    public function addReservation(Request $request,ParamFetcher $paramFetcher)
    {
        $idPdv= $paramFetcher->get('pdv');
        if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
            if ($this->getUser()->getPdv() != intval($idPdv)) {
                return new JsonResponse(null, 403);
            }
        }

        $dateHour = $paramFetcher->get('dateHour');
        $nbrPerson = intval($paramFetcher->get('nbrPerson'));
        $tablesid = $paramFetcher->get('tables');
        $comment = $paramFetcher->get('comment');
        $idPdv = intval($paramFetcher->get('pdv'));
        $idCustomerPdv = intval($paramFetcher->get('customer'));
        $datetime =  \DateTime::createFromFormat('D M d Y H:i:s e+', $dateHour);
        $date = $datetime->format('Y-m-d');
        $Heur = $datetime->format('H');
        $dateheuremysql = $datetime->format('Y-m-d H:i:') . ":00";
        $reservationDate = \DateTime::createFromFormat('Y-m-d', $date);
        $d = new \DateTime();
        $currentDate = new \DateTime($d->format('Y-m-d'));
        if ($reservationDate >= $currentDate && $Heur >= 7 && $Heur < 24) {
            $service = 0;
            if (7 <= $Heur && $Heur < 16) {
                $service = 1;
            } elseif (16 <= $Heur && $Heur < 20) {
                $service = 2;
            } elseif (20 <= $Heur && $Heur < 24) {
                $service = 3;
            }
            if ($service > 0 && count($tablesid) > 0 && !empty($idPdv)) {
                $em = $this->getDoctrine()->getManager();
                $q1 = "SELECT SUM(nbr_person) as somme from bench Where id IN (" . implode(',', $tablesid) . ");";
                $statement = $em->getConnection()->prepare($q1);
                $statement->execute();
                $rlt1 = $statement->fetch(\PDO::FETCH_ASSOC);
                $somme = $rlt1['somme'];
                if ($somme >= $nbrPerson) {
                    $q2 = "SELECT A.id , 
                                  (select GROUP_CONCAT(B.id) 
                                  from bench B, bench_binding C 
                                  where (B.id = C.benchSec_id AND C.benchInit_id=A.id) 
                                  or (B.id = C.benchInit_id AND C.benchSec_id=A.id)) as liaison 
                             FROM bench A 
                             WHERE A.id IN (" . implode(',', $tablesid) . ")
                             AND A.pdv_id=" . $idPdv . ";";
                    $statement = $em->getConnection()->prepare($q2);
                    $statement->execute();
                    $tables2 = array();
                    while ($row = $statement->fetch(\PDO::FETCH_ASSOC)) {
                        $tables2[] = $row;
                    }
                        if (count($tablesid) > 1) {
                            $list = array();
                            foreach ($tables2 as $table) {
                                $id = $table['id'];
                                $liaison = $table['liaison'];
                                $arrayLiason = explode(",", $liaison);
                                $list[$id] = $arrayLiason;
                            }
                            if ($this->cheakLiaison($list) != count($list)) {
                                return new JsonResponse([
                                    'message' => 'Liaison incorrect.',
                                    'error' => true
                                ]);
                            }

                        }

                    //////////////////////////On test si les tables selectionnées sont encore disponible//////////////////////////////////////////////////////////////////////////////////////////
                    $q3 = "SELECT A.id , 
                                    (select GROUP_CONCAT(B.id) 
                                     from bench B, bench_binding C 
                                     where (B.id = C.benchSec_id AND C.benchInit_id=A.id) 
                                     or (B.id = C.benchInit_id AND C.benchSec_id=A.id)) as liaison 
                             FROM bench A 
                             WHERE A.id IN (" . implode(',', $tablesid) . ") 	 
                             AND A.pdv_id=" . $idPdv . " 
                             AND A.id NOT IN ( SELECT rt.table_id 
                                                              FROM reservation_table AS rt,reservation AS r 
                                                              WHERE r.id=rt.reservation_id 
                                                              AND DATE(r.datetime)='" . $date . "'
                                                              AND r.service_id='" . $service . "')";
                    $res3 = $em->getConnection()->prepare($q3);
                    $res3->execute();

                    $tables3 = array();

                    while ($row = $res3->fetch(\PDO::FETCH_ASSOC)) {
                        $tables3[] = $row;
                    }

                    if ($tables2 == $tables3) {
                        $resrvation=new Reservation();
                        $customerPdv=null;
                        if (in_array($this->getUser()->getProfil()->getId(), [4, 3])) {
                            $pdv=$this->getDoctrine()->getRepository("App:Pdv")->find($idPdv);
                            $customerPdv=$this->getDoctrine()->getRepository("App:CustomerPdv")->findOneBy(array('id'=>$idCustomerPdv,'pdv'=>$pdv));
                        }else{
                            $customerPdv=$this->getDoctrine()->getRepository("App:CustomerPdv")->find($idCustomerPdv);
                        }
                        if(is_null($customerPdv)){
                            return new JsonResponse('error user dosent exist',400);
                        }
                        $service=$this->getDoctrine()->getRepository("App:Service")->find($service);
                        $resrvation->setDatetime($datetime);
                        $resrvation->setNbrPerson($nbrPerson);
                        $resrvation->setComment($comment);
                        $resrvation->setCustomerPdv($customerPdv);
                        $resrvation->setService($service);
                        $ip = $request->getClientIp();
                        $resrvation->setCreatedIp($ip);
                        $resrvation->setUpdatedIp('');
                        $resrvation->setCreatedUser($this->getUser());
                        $resrvation->setUpdatedUser(null);
                        $tables=[];
                        foreach ($tablesid as $idtable) {
                            $table=$this->getDoctrine()->getRepository("App:Bench")->find($idtable);
                            $tables[]=$table;
                        }
                        $resrvation->setTables($tables);
                        $em->persist($resrvation);
                        $em->flush($resrvation);

                        return new JsonResponse([
                            'message' => 'success',
                            'error' => false
                        ]);
                    } else {
                        return new JsonResponse([
                            'message' => 'Une des tables selectionées a été reserver par un autre utilisateur.',
                            'error' => true
                        ]);
                    }
                } else {
                    return new JsonResponse([
                        'message' => 'Le nombre de couvert des tables selectionnées et inférieur au nombre de personnes.',
                        'error' => true
                    ]);
                }
            } else {
                return new JsonResponse([
                    'message' => 'une erreur est survenue, merci de recommencer',
                    'error' => true
                ]);
            }
        }
    }

    /**
     * @Rest\Get("/reservations/day")
     */
    public function getReservationsDay(Request $request,ParamFetcher $paramFetcher)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $now = new \DateTime();
        $query = "r.id,r.datetime,r.comment,r.nbrPerson,s.label as service,c.firstname,c.lastname,c.phone,p.name as pdvName,p.id as idPdv";
        if (in_array($this->getUser()->getProfil()->getId(), [1, 5, 6])) {
            $query .= ",u.id as idUser,u.firstname as userFirstname,u.lastname as userLastname";
        }
        $reservations = $qb->select($query)
            ->from("App:Reservation", "r")
            ->innerJoin('r.customerPdv', 'cp');
        if (in_array($this->getUser()->getProfil()->getId(), [1, 5, 6])) {
            $reservations = $reservations->leftJoin('r.createdUser', 'u');
        }
        $reservations = $reservations->innerJoin('cp.customer', 'c')
            ->innerJoin('cp.pdv', 'p')
            ->innerJoin('r.service', 's')
            ->where('r.createdAt >=:date')
            ->andWhere('r.createdAt <=:date2');
        if ($this->getUser()->getPdv()) {
            $reservations = $reservations->andWhere('p.id =:pdv')
                ->setParameter('pdv', $this->getUser()->getPdv());
        }
        $reservations = $reservations->setParameter('date', $now->format('Y-m-d 00:00:00'))
            ->setParameter('date2', $now->format('Y-m-d 23:59:59'))
            ->getQuery()->getResult();
        foreach ($reservations as $key => $reservation) {
            $res = $em->getRepository('App:Reservation')->find($reservation['id']);
            $reservations[$key]['tables']=$res->getTables();
        }
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($reservations, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/reservations/historic")
     */
    public function getReservationsHistoric(Request $request,ParamFetcher $paramFetcher)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $query = "r.id,r.datetime,r.comment,r.nbrPerson,s.label as service,c.firstname,c.lastname,c.phone,p.name as pdvName,p.id as idPdv";
        if (in_array($this->getUser()->getProfil()->getId(), [1, 5, 6])) {
            $query .= ",u.id as idUser,u.firstname as userFirstname,u.lastname as userLastname";
        }
        $reservations = $qb->select($query)
            ->from("App:Reservation", "r")
            ->innerJoin('r.customerPdv', 'cp');
        if (in_array($this->getUser()->getProfil()->getId(), [1, 5, 6])) {
            $reservations = $reservations->leftJoin('r.createdUser', 'u');
        }
        $reservations = $reservations->innerJoin('cp.customer', 'c')
            ->innerJoin('cp.pdv', 'p')
            ->innerJoin('r.service', 's');
        if ($this->getUser()->getPdv()) {
            $reservations = $reservations->where('p.id =:pdv')
                ->setParameter('pdv', $this->getUser()->getPdv());
        }
        $reservations = $reservations->getQuery()->getResult();
        foreach ($reservations as $key => $reservation) {
            $res = $em->getRepository('App:Reservation')->find($reservation['id']);
            $reservations[$key]['tables']=$res->getTables();
        }
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($reservations, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Delete("/reservations/{id}")
     */
    public function deleteReservationsDay($id)
    {
        $em = $this->getDoctrine()->getManager();
        $res = $em->getRepository('App:Reservation')->find($id);
        $em->remove($res);
        $em->flush();
        return new JsonResponse();
    }

    private function cheakLiaison($array, $c = 1)
    {
        //////////////////////////////////////////////////////////////Si la liste contient au moins un element///////////////////////////////////
        if (count($array) > 0) {
            //////////////////////////////////////////////////////////je récupere les liaisons de premier element////////////////////////////////
            $keys = array_keys($array);
            $id = $keys[0];
            $liaison = $array[$id];
            /////////////////////////////////////////////////////////je supprime le premier element de la liste//////////////////////////////////
            unset($array[$id]);
            /////////////////////////////////////////////////////////je boucle sur les liaisons de premier element///////////////////////////////
            foreach ($liaison as $value) {
                ////////////////////////////////////////je test s'il l'element de la liste liaison existe dans ma liste//////////////////////////
                if (array_key_exists($value, $array)) {
                    /////////////////Si Oui j'incremente le compteur $c et je repete le meme scénario avec les liaisons de ce element////////////
                    $c = $this->cheakLiaison($array, $c) + 1;
                }
            }
        }
        /////////////////je returne le compteur $c////////////
        return $c;
    }
}