<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 15/02/2018
 * Time: 18:18
 */

namespace App\Controller\Rest;

use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Controller\Annotations\RequestParam;
use App\Entity\Element;
use App\Entity\ElementOrderType;
use App\Entity\ElementSize;
use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Request\ParamFetcher;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use DateTime;
use FOS\RestBundle\Controller\Annotations\QueryParam;

class StatisticsController extends FOSRestController
{

    /**
     * @Rest\Get("/statistics")
     */
    public function getStatistic()
    {
        $data = Array();
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ordersLastMonth = $qb->select("count(c.id) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's');
        if ($this->getUser()->getPdv()) {
            $ordersLastMonth = $ordersLastMonth->innerJoin('c.orderTypePdv', 'opt')
                ->innerJoin('opt.pdv', 'p');
        }
        $ordersLastMonth = $ordersLastMonth->where('s.id<>3')
            ->andWhere('MONTH(c.createdAt) =:month')
            ->andWhere('YEAR(c.createdAt) =:year');
        if ($this->getUser()->getPdv()) {
            $ordersLastMonth = $ordersLastMonth->andWhere('p.id=:pdv')
                ->setParameter('pdv', $this->getUser()->getPdv());
        }
        $ordersLastMonth = $ordersLastMonth->setParameter('month', date('m', strtotime("first day of previous month")))
            ->setParameter('year', date('Y', strtotime("first day of previous month")))
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['ordersLastMonth'] = $ordersLastMonth['total'];
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        $qb = $em->createQueryBuilder();
        $ordersCurrentMonth = $qb->select("count(c.id) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's');
        if ($this->getUser()->getPdv()) {
            $ordersCurrentMonth = $ordersCurrentMonth->innerJoin('c.orderTypePdv', 'opt')
                ->innerJoin('opt.pdv', 'p');
        }
        $ordersCurrentMonth = $ordersCurrentMonth->where('s.id<>3')
            ->andWhere('MONTH(c.createdAt) =:month')
            ->andWhere('YEAR(c.createdAt) =:year');
        if ($this->getUser()->getPdv()) {
            $ordersCurrentMonth = $ordersCurrentMonth->andWhere('p.id=:pdv')
                ->setParameter('pdv', $this->getUser()->getPdv());
        }
        $ordersCurrentMonth = $ordersCurrentMonth->setParameter('month', date('m'))
            ->setParameter('year', date('Y'))
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['ordersCurrentMonth'] = $ordersCurrentMonth['total'];
        /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $qb = $em->createQueryBuilder();
        $CALastMonth = $qb->select("sum(c.amount * (100-c.discount)/100) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's');
        if ($this->getUser()->getPdv()) {
            $CALastMonth = $CALastMonth->innerJoin('c.orderTypePdv', 'opt')
                ->innerJoin('opt.pdv', 'p');
        }
        $CALastMonth = $CALastMonth->where('s.id<>3')
            ->andWhere('MONTH(c.createdAt) =:month')
            ->andWhere('YEAR(c.createdAt) =:year');
        if ($this->getUser()->getPdv()) {
            $CALastMonth = $CALastMonth->andWhere('p.id=:pdv')
                ->setParameter('pdv', $this->getUser()->getPdv());
        }
        $CALastMonth = $CALastMonth->setParameter('month', date('m', strtotime("first day of previous month")))
            ->setParameter('year', date('Y', strtotime("first day of previous month")))
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['CALastMonth'] = $CALastMonth['total'];
        $mtlastmonth = $CALastMonth['total'];
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $qb = $em->createQueryBuilder();
        $CACurrentMonth = $qb->select("sum(c.amount * (100-c.discount)/100) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's');
        if ($this->getUser()->getPdv()) {
            $CACurrentMonth = $CACurrentMonth->innerJoin('c.orderTypePdv', 'opt')
                ->innerJoin('opt.pdv', 'p');
        }
        $CACurrentMonth = $CACurrentMonth->where('s.id<>3')
            ->andWhere('MONTH(c.createdAt) =:month')
            ->andWhere('YEAR(c.createdAt) =:year');
        if ($this->getUser()->getPdv()) {
            $CACurrentMonth = $CACurrentMonth->andWhere('p.id=:pdv')
                ->setParameter('pdv', $this->getUser()->getPdv());
        }
        $CACurrentMonth = $CACurrentMonth->setParameter('month', date('m'))
            ->setParameter('year',  date('Y'))
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['CACurrentMonth'] = $CACurrentMonth['total'];
        $mtmonth = $CACurrentMonth['total'];
        if ($mtlastmonth == 0) {
            $mtlastmonth = 1;
        }
        $evolution = (($mtmonth - $mtlastmonth) / $mtlastmonth) * 100;
        $evolution = round($evolution, 2);
        $data['evolution'] = $evolution;
        return new JsonResponse($data, 200);
    }

    /**
     * @Rest\Get("/statistics/admin/ca")
     */
    public function getStatisticCA()
    {
        if ($this->getUser()->getProfil()->getId()!=5) {
            return new JsonResponse('', 403);
        }
        $data = Array();
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ordersYesterday= $qb->select("sum(c.amount * (100-c.discount)/100) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's')
            ->where('s.id<>3')
            ->andWhere("DATE(c.createdAt)=DATE_SUB(CURRENT_DATE(),1,'DAY')")
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['CAYesterday'] = $ordersYesterday['total'];
        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        $qb = $em->createQueryBuilder();
        $ordersDay= $qb->select("sum(c.amount * (100-c.discount)/100) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's')
            ->where('s.id<>3')
            ->andWhere("DATE(c.createdAt)=CURRENT_DATE()")
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['CADay'] = $ordersDay['total'];
        /////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $qb = $em->createQueryBuilder();
        $CALastMonth = $qb->select("sum(c.amount * (100-c.discount)/100) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's')
            ->where('s.id<>3')
            ->andWhere('MONTH(c.createdAt) =:month')
            ->andWhere('YEAR(c.createdAt) =:year')
            ->setParameter('month', date('m', strtotime("first day of previous month")))
            ->setParameter('year', date('Y', strtotime("first day of previous month")))
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['CALastMonth'] = $CALastMonth['total'];
        $mtlastmonth = $CALastMonth['total'];
        // ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $qb = $em->createQueryBuilder();
        $CACurrentMonth = $qb->select("sum(c.amount * (100-c.discount)/100) as total")
            ->from("App:Command", "c")
            ->innerJoin('c.status', 's')
            ->where('s.id<>3')
            ->andWhere('MONTH(c.createdAt) =:month')
            ->andWhere('YEAR(c.createdAt) =:year')
            ->setParameter('month', date('m'))
            ->setParameter('year',  date('Y'))
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $data['CACurrentMonth'] = $CACurrentMonth['total'];
        return new JsonResponse($data, 200);
    }

    /**
     * @Rest\Post("/statistics/ticketz/orders")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="date", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="menu", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="product", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="orderTypes", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="paymentModes", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="service", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="team", nullable=true,allowBlank=true,strict=true)
     */
    public function getTicketzOrders(ParamFetcher $paramFetcher)
    {
        $date = \DateTime::createFromFormat('D M d Y H:i:s e+', $paramFetcher->get('date'));
        $service = $paramFetcher->get('service');
        $team = $paramFetcher->get('team');
        $paymentModes = $paramFetcher->get('paymentModes');
        $orderTypes = $paramFetcher->get('orderTypes');
        $ids = $this->getOrdersIds($date, $service, $team, $paymentModes, $orderTypes);
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($ids, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Post("/statistics/ticketz/totalAmount")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="orders", nullable=false,allowBlank=false,strict=true)
     */
    public function getTotalAmount(ParamFetcher $paramFetcher)
    {
        $ids = $paramFetcher->get('orders');
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $result = $qb->select("SUM(co.amount) as amount")
            ->from("App:Command", "co")
            ->andWhere('co.id IN (:ids)')
            ->setParameter('ids', $ids)
            ->setMaxResults(1)
            ->getQuery()
            ->getOneOrNullResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($result, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Post("/statistics/ticketz/modeRep")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="orders", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="paymentModes", nullable=false,allowBlank=false,strict=true)
     */
    public function getTicketzModeRep(ParamFetcher $paramFetcher)
    {
        $ids = $paramFetcher->get('orders');
        $paymentModes = $paramFetcher->get('paymentModes');
        if (!is_array($ids) || !is_array($paymentModes)) {
            return new JsonResponse('orders or paymentModes is not array', 400);
        }
        $em = $this->getDoctrine()->getManager();
        $tab = [];
        forEach ($paymentModes as $paymentMode) {
            $qb = $em->createQueryBuilder();
            $order = $qb->select("mp.label,SUM(cmp.amount) as amount")
                ->from("App:Command", "co")
                ->innerJoin('co.commandPaymentModes', 'cmp')
                ->innerJoin('cmp.paymentMode', 'mp')
                ->where('mp.id =:paymentMode')
                ->andWhere('co.id in (:ids)')
                ->setParameter('paymentMode', $paymentMode)
                ->setParameter('ids', $ids)
                ->setMaxResults(1)->getQuery()->getOneOrNullResult();
            if (is_null($order['amount'])) {
                $order['amount'] = 0;
            }
            $tab[] = $order;
        }
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($tab, 'json');
        return new JsonResponse(json_decode($data));
    }


    /**
     * @Rest\Post("/statistics/ticketz/typeRep")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="orders", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="orderTypes", nullable=false,allowBlank=false,strict=true)
     */
    public function getTicketzTypeRep(ParamFetcher $paramFetcher)
    {
        $ids = $paramFetcher->get('orders');
        $orderTypes = $paramFetcher->get('orderTypes');
        if (!is_array($ids) || !is_array($orderTypes)) {
            return new JsonResponse('orders or orderTypes is not array', 400);
        }
        $em = $this->getDoctrine()->getManager();
        $tab = [];
        forEach ($orderTypes as $orderType) {
            $qb = $em->createQueryBuilder();
            $order = $qb->select("t.label,COUNT(DISTINCT co.id) as cmd")
                ->from("App:Command", "co")
                ->leftJoin('co.orderTypePdv', 'mop')
                ->leftJoin('mop.orderType', 't')
                ->Where('t.id =:orderT')
                ->andWhere('co.id in (:ids)')
                ->setParameter('orderT', $orderType)
                ->setParameter('ids', $ids)
                ->setMaxResults(1)->getQuery()->getOneOrNullResult();
            if (count($ids) == 1) {
                $orderTypeName = $em->getRepository('App:OrderType')->find($orderType)->getLabel();
                $order['label'] = $orderTypeName;
                if (is_null($order['cmd'])) {
                    $order['cmd'] = 0;
                }
            }
            $tab[] = $order;
        }
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($tab, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Post("/statistics/ticketz/team")
     * @RequestParam(name="orders", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="team", nullable=true,allowBlank=true,strict=true)
     */
    public function getTicketzTeam(ParamFetcher $paramFetcher)
    {

        $ids = $paramFetcher->get('orders');
        $team = $paramFetcher->get('team');
        if (!is_array($ids) || !is_array($team)) {
            return new JsonResponse('orders or team is not array', 400);
        }
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $tab = $qb->select("team.designation,COUNT(co.id) as cmd")
            ->from("App:Command", "co");
                $tab->leftJoin('co.team', 'team');
                if (count($team) > 0) {
                    $tab = $tab->where('team.id in (:team)')
                        ->setParameter('team', $team);
                }
                $tab = $tab->andWhere('co.id in (:ids)')
                    ->setParameter('ids', $ids)
                    ->groupBy("team.designation")
                    ->getQuery()
                    ->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($tab, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Post("/statistics/ticketz/service")
     * @RequestParam(name="orders", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="service", nullable=false,allowBlank=false,strict=true)
     */
    public function getTicketzService(ParamFetcher $paramFetcher)
    {

        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ids = $paramFetcher->get('orders');
        $service = intval($paramFetcher->get('service'));
        $order = $qb->select("SUM(co.amount) as amount,COUNT(co.id) as nbrCmd")
            ->from("App:Command", "co")
            ->where('co.id in (:ids)')
            ->setParameter('ids', $ids);
        if ($service == 1) {
            $order = $order->andWhere('HOUR(co.createdAt) < 16');
        }
        if ($service == 2) {
            $order = $order->andWhere('HOUR(co.createdAt) >= 16');
        }
        $order = $order->setMaxResults(1)->getQuery()->getOneOrNullResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($order, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Post("/statistics/ticketz/product")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="orders", nullable=false,allowBlank=false,strict=true)
     */
    public function getTicketzProduct(ParamFetcher $paramFetcher)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ids = $paramFetcher->get('orders');
        $result = $qb->select("ce.name,SUM(ce.total) as total,SUM(ce.quantity) as nbr")
            ->from("App:CommandElement", "ce")
            ->innerJoin('ce.command', 'co')
            ->leftJoin('ce.commandMenu', 'cm')
            ->andWhere('co.id IN (:ids)')
            ->andWhere('cm.id IS NULL')
            ->setParameter('ids', $ids)
            ->groupBy('ce.name')
            ->orderBy('nbr','DESC')
            ->getQuery()
            ->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($result, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Post("/statistics/ticketz/menu")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="orders", nullable=false,allowBlank=false,strict=true)
     */
    public function getTicketMenu(ParamFetcher $paramFetcher)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $ids = $paramFetcher->get('orders');
        $result = $qb->select("cm.title,SUM(cm.total) as total,SUM(cm.quantity) as nbr")
            ->from("App:CommandMenu", "cm")
            ->innerJoin('cm.command', 'co')
            ->andWhere('co.id IN (:ids)')
            ->setParameter('ids', $ids)
            ->groupBy('cm.title')
            ->orderBy('nbr','DESC')
            ->getQuery()
            ->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($result, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/statistics/admin")
     * @QueryParam(name="type", nullable=false,allowBlank=false,strict=false)
     * @QueryParam(name="month", nullable=true,allowBlank=true,strict=true)
     * @QueryParam(name="dateD", nullable=true,allowBlank=true,strict=true)
     * @QueryParam(name="dateF", nullable=true,allowBlank=true,strict=true)
     * @QueryParam(name="pdv", nullable=true,allowBlank=true,strict=true)
     */
    public function getOrdersCNandCA(ParamFetcher $paramFetcher)
    {
        if ($this->getUser()->getProfil()->getId()!=5) {
            return new JsonResponse('', 403);
        }
        $type=intval($paramFetcher->get('type'));
        if($type!=1 && $type!=2){
            return new JsonResponse('type invalide',400);
        }
        if($type==1){
            $dateD = \DateTime::createFromFormat('D M d Y H:i:s e+', $paramFetcher->get('dateD'));
            $dateF = \DateTime::createFromFormat('D M d Y H:i:s e+', $paramFetcher->get('dateF'));
            if(!$dateD || !$dateF || $dateD>$dateF){
                return new JsonResponse('date debut ou date de fin invalide',400);
            }
        }else{
            $monthYear= \DateTime::createFromFormat('D M d Y H:i:s e+', $paramFetcher->get('month'));
            if(!$monthYear){
                return new JsonResponse('mois/annee invalide',400);
            }
        }
        $em = $this->getDoctrine()->getManager();
        $CAandCN=array();
        $qb2 = $em->createQueryBuilder();
        $pdvs= $qb2->select("count(co.id) as nc,p.name,p.id")
            ->from("App:Command", "co")
            ->innerJoin('co.status', 's')
            ->innerJoin('co.orderTypePdv', 'opt')
            ->innerJoin('opt.pdv', 'p');
        if ($type==1) {
            $pdvs = $pdvs->andWhere('co.createdAt >= :date_start')
                     ->andWhere('co.createdAt <= :date_end')
                     ->setParameter('date_start', $dateD->format('Y-m-d 00:00:00'))
                     ->setParameter('date_end', $dateF->format('Y-m-d 23:59:59'));
        }else{
            $pdvs = $pdvs->andWhere('MONTH(co.createdAt) = :month')
                     ->andWhere('YEAR(co.createdAt) =:year')
                     ->setParameter('month', $monthYear->format('m'))
                     ->setParameter('year', $monthYear->format('Y'));
        }
        if ($paramFetcher->get('pdv')) {
            $pdvs = $pdvs->andWhere('p.id=:pdv')->setParameter('pdv', intval($paramFetcher->get('pdv')));
        }else{
        	$pdvs = $pdvs->groupBy('p.id');
        }
        $pdvs = $pdvs->getQuery()->getResult();
        foreach ($pdvs as $key => $pdv) {
        	$qb = $em->createQueryBuilder();
        	$CA= $qb->select("sum(co.amount * (100-co.discount)/100) as ca")
		            ->from("App:Command", "co")
		            ->innerJoin('co.status', 's')
		            ->innerJoin('co.orderTypePdv', 'opt')
			        ->innerJoin('opt.pdv', 'p')
		            ->where('s.id<>3')
		            ->andWhere('p.id=:pdv');
	        if ($type==1) {
	            $CA = $CA->andWhere('co.createdAt >= :date_start')
	                     ->andWhere('co.createdAt <= :date_end')
	                     ->setParameter('date_start', $dateD->format('Y-m-d 00:00:00'))
	                     ->setParameter('date_end', $dateF->format('Y-m-d 23:59:59'));

	        }else{
	            $CA = $CA->andWhere('MONTH(co.createdAt) = :month')
	                     ->andWhere('YEAR(co.createdAt) =:year')
	                     ->setParameter('month', $monthYear->format('m'))
	                     ->setParameter('year', $monthYear->format('Y'));
	        }
	        $CA = $CA->setParameter('pdv', $pdv['id']);
	        $CA = $CA->setMaxResults(1)->getQuery()->getOneOrNullResult();
	        $pdvs[$key]['ca']=($CA['ca'])?$CA['ca']:0;
        }
        //$CAandCN['ca']=$CA['ca'];
        //$CAandCN['nc']=$CN['nc'];
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($pdvs, 'json');
        return new JsonResponse(json_decode($data));
    }

    public function getOrdersIds($date, $service, $team, $paymentModes, $orderTypes)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $orders = $qb->select("co.id")
            ->from("App:Command", "co")
            ->innerJoin('co.commandPaymentModes', 'cmp')
            ->innerJoin('cmp.paymentMode', 'mp')
            ->innerJoin('co.orderTypePdv', 'mop')
            ->innerJoin('mop.pdv', 'p')
            ->innerJoin('mop.orderType', 't')
            ->innerJoin('co.status', 's')
            ->leftJoin('co.team', 'team')
            ->where('s.id IS NOT NULL')
            ->andWhere('p.id =:pdv')
            ->setParameter('pdv', $this->getUser()->getPdv());
        if ($date && $service == 1) {
            $orders = $orders->andWhere('co.createdAt <= :date1')
                ->andWhere('co.createdAt >= :date2')
                ->setParameter('date1', $date->format('Y-m-d 16:00:00'))
                ->setParameter('date2', $date->format('Y-m-d 00:00:00'));
        }
        if ($date && $service == 2) {
            $orders = $orders->andWhere('co.createdAt >= :date1')
                ->andWhere('co.createdAt <= :date2')
                ->setParameter('date1', $date->format('Y-m-d 16:00:00'))
                ->setParameter('date2', $date->format('Y-m-d 23:59:59'));
        }
        if ($date && $service == 3) {
            $orders = $orders->andWhere('co.createdAt >= :date')
                ->andWhere('DATE(co.createdAt) = :date')
                ->setParameter('date', $date->format('Y-m-d 00:00:00'));
        }
        if (count($team) > 0) {
            $orders = $orders->andWhere('team.id IN (:tea)')
                ->setParameter('tea', $team);
        }
        if ($paymentModes) {
            $orders = $orders->andWhere('mp.id IN (:paymentModes)')
                ->setParameter('paymentModes', $paymentModes);
        }
        if ($orderTypes) {
            $orders = $orders->andWhere('t.id IN (:orderT)')
                ->setParameter('orderT', $orderTypes);
        }
        $orders = $orders
            ->groupBy('co.id')
            ->getQuery()->getScalarResult();
        $ids = array_column($orders, "id");
        return $ids;
    }

}

