<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 28/05/2018
 * Time: 15:12
 */

namespace App\Controller\Rest;

use App\Service\SendEvent;
use Doctrine\ORM\Query;
use Doctrine\ORM\Tools\Pagination\Paginator;
use FOS\RestBundle\Request\ParamFetcher;
use FOS\RestBundle\Controller\Annotations\RequestParam;
use http\Env\Response;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;

class UserController extends Controller
{
    /**
     * @Rest\Post("/users")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="email", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="firstname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="lastname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="password", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="pdv", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="function", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="avatar", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="profil", nullable=true,allowBlank=true,strict=true)
     */
    public function postUser(ParamFetcher $paramFetcher)
    {
        $userManager = $this->get('fos_user.user_manager');
        $email_exist = $userManager->findUserByEmail($paramFetcher->get('email'));
        if ($email_exist) {
            return new JsonResponse('', 409);
        }
        $profil = $this->getDoctrine()->getRepository("App:Profil")->find($paramFetcher->get('profil'));
        if (is_null($profil)) {
            return new JsonResponse('profil invalide', 400);
        }
        $rules=$this->getBaserights($paramFetcher->get('profil'));
        $user = $userManager->createUser();
        switch ($paramFetcher->get('profil')) {
            case 5 :
                return new JsonResponse('', 403);
                break;
            case 1 :
                {
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 6 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTSUPERV')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 2 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTOPE')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 3 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 4 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
        }
        $user->setRoles($rules);
        if ($paramFetcher->get('avatar') != '') {
            $decoded = base64_decode(substr($paramFetcher->get('avatar'), 22));
            $f = finfo_open();
            $mime_type = finfo_buffer($f, $decoded, FILEINFO_MIME_TYPE);
            $split = explode('/', $mime_type);
            $type = $split[1];
            $filename = md5(uniqid()) . '.' . $type;
            $path = $this->getParameter('users_directory') . '/' . $filename;
            $user->setAvatar($filename);
            file_put_contents($path, $decoded);
        } else {
            $user->setAvatar('');
        }
        $user->setProfil($profil);
        $user->setUsername($paramFetcher->get('email'));
        $user->setFirstname($paramFetcher->get('firstname'));
        $user->setLastname($paramFetcher->get('lastname'));
        $user->setEmail($paramFetcher->get('email'));
        $user->setEmailCanonical($paramFetcher->get('email'));
        $user->setEnabled(1);
        $user->setPlainPassword($paramFetcher->get('password'));
        $userManager->updateUser($user);
        return new JsonResponse([
            'id' => $user->getId(),
            'success' => true,
            'code' => 200
        ]);
    }

    /**
     * @Rest\Put("/users/{id}/info")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="email", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="firstname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="lastname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="password", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="pdv", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="function", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="avatar", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="oldPassword", nullable=true,allowBlank=true,strict=true)
     */
    public function updateUser(ParamFetcher $paramFetcher, $id)
    {
        $em = $this->getDoctrine()->getManager();
        $user = $em->getRepository('App:User')->find($id);
        if (!is_null($user)) {
            $userManager = $this->get('fos_user.user_manager');
            switch ($user->getProfil()->getId()) {
                case 5 :
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    } else {
                        $factory = $this->get('security.encoder_factory');
                        $encoder = $factory->getEncoder($user);
                        if (!$encoder->isPasswordValid($user->getPassword(), $paramFetcher->get('oldPassword'), $user->getSalt())) {
                            return new JsonResponse('Votre mot de passe est incorrect', 400);
                        }
                    }
                    break;
                case 1 :
                    {
                        if ($this->getUser()->getProfil()->getId() != 5) {
                            return new JsonResponse('', 403);
                        }
                        break;
                    }
                case 6 :
                    {
                        if (!$this->getUser()->hasRole('RULE_MANAGEMENTSUPERV')) {
                            return new JsonResponse('', 403);
                        }
                        break;
                    }
                case 2 :
                    {
                        if (!$this->getUser()->hasRole('RULE_MANAGEMENTOPE')) {
                            return new JsonResponse('', 403);
                        }
                        break;
                    }
                case 3 :
                    {
                        if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
                            return new JsonResponse('', 403);
                        }
                        break;
                    }
                case 4 :
                    {
                        if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
                            return new JsonResponse('', 403);
                        }
                        break;
                    }

            }
            if ($user->getEmail() != $paramFetcher->get('email')) {
                $email_exist = $userManager->findUserByEmail($paramFetcher->get('email'));
                if ($email_exist) {
                    return new JsonResponse('', 409);
                }
            }
            if ($paramFetcher->get('avatar') != '') {
                if (substr($paramFetcher->get('avatar'), 0, 4) == 'data') {
                    $decoded = base64_decode(substr($paramFetcher->get('avatar'), 22));
                    $f = finfo_open();
                    $mime_type = finfo_buffer($f, $decoded, FILEINFO_MIME_TYPE);
                    $split = explode('/', $mime_type);
                    $type = $split[1];
                    $filename = md5(uniqid()) . '.' . $type;
                    $path = $this->getParameter('users_directory') . '/' . $filename;
                    $user->setAvatar($filename);
                    file_put_contents($path, $decoded);
                }
            } else {
                if ($user->getAvatar() != '') {
                    $avatar = $this->getParameter('users_directory') . "/" . $user->getAvatar();
                    if (file_exists($avatar))
                        unlink($avatar);
                    $user->setAvatar('');
                }
            }
            $user->setUsername($paramFetcher->get('email'));
            $user->setfirstname($paramFetcher->get('firstname'));
            $user->setlastname($paramFetcher->get('lastname'));
            $user->setEmail($paramFetcher->get('email'));
            $user->setEmailCanonical($paramFetcher->get('email'));
            if ($paramFetcher->get('password') != '') {
                $user->setPlainPassword($paramFetcher->get('password'));
            }
            $userManager->updateUser($user);
            return new JsonResponse([], 200);
        } else {
            return new JsonResponse('', 400);
        }

    }

    /**
     * @Rest\Put("/users/{id}/rules")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="rules", nullable=true,allowBlank=true,strict=true)
     */
    public function updateUserRules(ParamFetcher $paramFetcher, $id,SendEvent $sendEvent)
    {
        $em = $this->getDoctrine()->getManager();
        $rules = $paramFetcher->get('rules');
        $user = $em->getRepository('App:User')->find($id);
        $userManager = $this->get('fos_user.user_manager');
        $profil = $user->getProfil()->getId();
        switch ($profil) {
            case 5 :
                return new JsonResponse('', 403);
                break;
            case 1 :
                {
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 6 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTSUPERV')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 2 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTOPE')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 3 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 4 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }

        }
        $defaultRules = $this->getRightsByProfil($profil);
        foreach ($rules as $rule) {
            if (!in_array($rule, $defaultRules)) {
                var_dump($rule, $defaultRules);
                return new JsonResponse('', 400);
            }
            $user->setRoles($rules);
        }
        $userManager->updateUser($user);
        if($profil==4 || $profil==3){
            $sendEvent->sendMessage(['type' => 'refreshRest','pdv'=>$user->getPdv()]);
        }
        return new JsonResponse();
    }

    /**
     * @Rest\Put("/users/{id}/status")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="status", nullable=true,allowBlank=true,strict=true)
     */
    public function enableUser(ParamFetcher $paramFetcher, $id,SendEvent $sendEvent)
    {
        $userManager = $this->get('fos_user.user_manager');
        $em = $this->getDoctrine()->getManager();
        $user = $em->getRepository('App:User')->find($id);
        switch ($user->getProfil()->getId()) {
            case 3 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 4 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 2 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTOPE')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 6 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTSUPERV')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 1 :
                {
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
        }
        if($user->getProfil()->getId()==3 && $paramFetcher->get('status')==false){
            $sendEvent->sendMessage(['type' => 'refreshRest','pdv'=>$user->getPdv()]);
        }
        if (!is_null($user)) {
            $user->setEnabled($paramFetcher->get('status'));
            $userManager->updateUser($user);
            return new JsonResponse();
        } else {
            return new JsonResponse('', 400);
        }

    }

    /**
     * @Rest\Get("/user")
     */
    public function getUserInfo()
    {
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($this->getUser(), 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/user/{id}")
     */
    public function getUserById($id)
    {
        $em = $this->getDoctrine()->getManager();
        $user = $em->getRepository('App:User')->find($id);
        switch ($user->getProfil()->getId()) {
            case 3 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 4 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 2 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTOPE')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 6 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTSUPERV')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 1 :
                {
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
        }
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($user, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/users/{id}/rights")
     */
    public function getRights($id)
    {
        $em = $this->getDoctrine()->getManager();
        $user = $em->getRepository('App:User')->find($id);
        switch ($user->getProfil()->getId()) {
            case 3 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTRIGHTREST')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 4 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTRIGHTTEAM')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 2 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTRIGHTOPE')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 6 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTRIGHTSUPERV')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 1 :
                {
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
        }
        $userRights = $user->getRoles();
        $qb = $em->createQueryBuilder();
        $r = $qb->select("r.id,r.rule,r.label,case when r.rule in (:userRigths) then 1 else 0 end as checked")
            ->from("App:ProfilRights", "pr")
            ->innerJoin('pr.rights', 'r')
            ->innerJoin('pr.profil', 'p')
            ->where('p.id = :idP')
            ->setParameter('idP', $user->getProfil()->getId())
            ->setParameter('userRigths', $userRights)
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($r, 'json');
        return new JsonResponse(json_decode($data));

    }

    /**
     * @Rest\Get("/users/profil/{id}")
     */
    public function getUsers($id)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        switch ($id) {
            case 3 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 4 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 2 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTOPE')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 6 :
                {
                    if (!$this->getUser()->hasRole('RULE_MANAGEMENTSUPERV')) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
            case 1 :
                {
                    if ($this->getUser()->getProfil()->getId() != 5) {
                        return new JsonResponse('', 403);
                    }
                    break;
                }
        }
        $operators = $qb->select("u")
            ->from("App:User", "u")
            ->innerJoin('u.profil', 'p')
            ->where('p.id = :id')
            ->setParameter('id', $id)
            ->getQuery()->getResult();
        $serializer = $this->get('serializer');
        $data = $serializer->serialize($operators, 'json');
        return new JsonResponse(json_decode($data));
    }

    /**
     * @Rest\Get("/users/operators")
     */
    public function getOperators()
    {
        if (in_array($this->getUser()->getProfil()->getId(), [1, 5, 6])) {
            $em = $this->getDoctrine()->getManager();
            $qb = $em->createQueryBuilder();
            $operators = $qb->select("u.id,u.firstname,u.lastname")
                ->from("App:User", "u")
                ->innerJoin('u.profil', 'p')
                ->where('p.id = :id')
                ->andWhere('u.enabled = :enabled')
                ->setParameter('id', 2)
                ->setParameter('enabled', 1)
                ->getQuery()->getResult();
            $serializer = $this->get('serializer');
            $data = $serializer->serialize($operators, 'json');
            return new JsonResponse(json_decode($data));
        }
        return new JsonResponse([]);

    }

    /**
     * @Rest\Post("/users/contact")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="id", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="pdv", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="password", nullable=false,allowBlank=false,strict=true)
     */
    public function addUser(ParamFetcher $paramFetcher)
    {
        if ($this->getUser()->getProfil()->getId() == 3 || $this->getUser()->getProfil()->getId() == 4) {
            return new JsonResponse([], 403);
        }
        $id = intval($paramFetcher->get('id'));
        $pdv = intval($paramFetcher->get('pdv'));
        $contact = $this->getDoctrine()->getRepository("App:Contact")->find($id);
        $userManager = $this->get('fos_user.user_manager');
        $user2 = $userManager->findUserByEmail($contact->getEmail());
        if ($user2) {
            if ($user2->getContact() == $id) {
                $user2->setEnabled(1);
                $userManager->updateUser($user2);
                return new JsonResponse('', 200);
            }
            return new JsonResponse('', 409);
        }

        if (!$this->getUser()->hasRole('RULE_MANAGEMENTREST')) {
            return new JsonResponse('', 403);
        } else {
            $user = $userManager->createUser();
            $rules=$this->getBaserights(3);
            $user->setRoles($rules);
            $profil = $this->getDoctrine()->getRepository("App:Profil")->find(3);
            $user->setProfil($profil);
            $user->setUsername($contact->getEmail());
            $user->setFirstname($contact->getFirstname());
            $user->setLastname($contact->getLastname());
            $user->setEmail($contact->getEmail());
            $user->setEmailCanonical($contact->getEmail());
            $user->setEnabled(1);
            $user->setContact($id);
            $user->setPdv($pdv);
            $user->setPlainPassword($paramFetcher->get('password'));
            $userManager->updateUser($user);
            return new JsonResponse('', 200);
        }

    }

    /**
     * @Rest\Post("/users/team")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="id", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="password", nullable=false,allowBlank=false,strict=true)
     */
    public function addTeamToUser(ParamFetcher $paramFetcher)
    {
        $id = intval($paramFetcher->get('id'));
        $pdv = $this->getUser()->getPdv();
        $team = $this->getDoctrine()->getRepository("App:Team")->find($id);
        $userManager = $this->get('fos_user.user_manager');
        $user2 = $userManager->findUserByEmail($team->getEmail());
        if ($user2) {
            if ($user2->getTeam() == $id) {
                $user2->setEnabled(1);
                $userManager->updateUser($user2);
                return new JsonResponse('', 200);
            }
            return new JsonResponse('', 409);
        }
        if (!$this->getUser()->hasRole('RULE_MANAGEMENTTEAM')) {
            return new JsonResponse('', 403);
        } else {
            $user = $userManager->createUser();
            $rules=$this->getBaserights(4);
            $user->setRoles($rules);
            $profil = $this->getDoctrine()->getRepository("App:Profil")->find(4);
            $user->setProfil($profil);
            $user->setUsername($team->getEmail());
            $user->setFirstname($team->getFirstname());
            $user->setLastname($team->getLastname());
            $user->setEmail($team->getEmail());
            $user->setEmailCanonical($team->getEmail());
            $user->setEnabled(1);
            $user->setTeam($id);
            $user->setPdv($pdv);
            $user->setPlainPassword($paramFetcher->get('password'));
            $userManager->updateUser($user);
            return new JsonResponse('', 200);
        }

    }

    private function getRightsByProfil($idP)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $r = $qb->select("r.rule")
            ->from("App:ProfilRights", "rp")
            ->innerJoin('rp.rights', 'r')
            ->innerJoin('rp.profil', 'p')
            ->where('p.id = :idP')
            ->setParameter('idP', $idP)
            ->getQuery()->getResult(Query::HYDRATE_ARRAY);
        $result = array_map(function ($value) {
            return $value['rule'];
        }, $r);
        return $result;
    }

    /**
     * @Rest\Post("/users/check")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="email", nullable=true,allowBlank=true,strict=true)
     */
    public function checkUser(ParamFetcher $paramFetcher)
    {
        $userManager = $this->get('fos_user.user_manager');
        $email_exist = $userManager->findUserByEmail($paramFetcher->get('email'));
        if ($email_exist) {
            return new JsonResponse('', 409);
        }
        return new JsonResponse('', 200);
    }

    private function getBaserights($profil){
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $r=$qb->select("r.rule")
            ->from("App:ProfilRights", "pr")
            ->innerJoin('pr.rights', 'r')
            ->innerJoin('pr.profil', 'p')
            ->where('p.id = :idP')
            ->andWhere('pr.base = 1')
            ->setParameter('idP', $profil)
            ->getQuery()->getResult();
        $rules = array_column($r, "rule");
        return $rules;
    }


}