<?php
/**
 * Created by PhpStorm.
 * User: PC
 * Date: 26/04/2018
 * Time: 16:01
 */

namespace App\Controller\Rest;


use Doctrine\ORM\Query;
use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Request\ParamFetcher;
use FOS\RestBundle\Controller\Annotations\RequestParam;
use RestocallBundle\Entity\Address;
use RestocallBundle\Entity\CardFamily;
use App\Entity\Customer;
use App\Entity\CustomerPdv;
use App\Entity\Size;
use App\Entity\webSiteUsers;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Intl\Tests\Data\Bundle\Writer\JsonBundleWriterTest;
use Symfony\Component\Validator\Constraints\DateTime;
use Nelmio\ApiDocBundle\Annotation\ApiDoc;
use ElephantIO\Client;
use ElephantIO\Engine\SocketIO\Version1X;
use \Firebase\JWT\JWT;

/**
 * @Route("/api")
 */
class WebSiteUsersController extends FOSRestController
{
    /**
     * @Rest\Post("/webSiteUsers/users")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="email", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="lastname", nullable=false,allowBlank=false,strict=true)
     * @ApiDoc(
     *      resource=true,
     *      description="Ajouter un utilisateur",
     *
     * )
     */
    public function addUser($lastname, $email, $customer)
    {
        $pass = hash('sha256', $lastname);
        $password = substr($pass, 1, 6);
        $newPass = $this->dec_enc('encrypt', $password);
        $em = $this->getDoctrine()->getManager();
        $user = new webSiteUsers();
        $user->setEmail($email);
        $user->setPassword($newPass);
        $user->setCustomer($customer);
        $em->persist($user);
        $em->flush();

            $to      = $email;
            $subject = 'Andiamo:information de votre compte';
            $message = 'Bienvenu, votre mot de passe est : ' . $password;
            $headers = 'From: andiamo@restocall.com';
            mail($to, $subject, $message, $headers);
        return $password;
    }

    /**
     * @Rest\Post("/webSiteUsers/customers")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="firstname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="lastname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="society", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="phone", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="secondaryPhone", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="email", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="streetName", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="streetNumber", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="postalCode", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="city", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="complementAddress", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="inputCode", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="building", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="staircase", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="floor", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="intercom", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="door", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="smsAuthorized", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="country", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="comment", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="pdv", nullable=false,allowBlank=false,strict=true)
     */
    public function addCustomer(Request $request, ParamFetcher $paramFetcher)
    {
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $user = $qb->select("u")
            ->from("RestocallBundle:webSiteUsers", "u")
            ->InnerJoin('u.customer', 'cp')
            ->InnerJoin('cp.pdv', 'p')
            ->where('u.email = :email')
            ->andWhere('p.id=:pdv')
            ->setParameter('email', $paramFetcher->get('email'))
            ->setParameter('pdv', $paramFetcher->get('pdv'))
            ->setMaxResults(1)
            ->getQuery()->getOneOrNullResult();
        if (is_null($user)) {
            $pdv = $this->getDoctrine()->getRepository("RestocallBundle:Pdv")->find($paramFetcher->get('pdv'));
                $customer = new Customer();
                $customer->setFirstname($paramFetcher->get('firstname'));
                $customer->setLastname($paramFetcher->get('lastname'));
                $customer->setSociety($paramFetcher->get('society'));
                $customer->setPhone($paramFetcher->get('phone'));
                $customer->setSecondaryPhone($paramFetcher->get('secondaryPhone'));
                $customer->setEmail($paramFetcher->get('email'));
                $customer->setSmsAuthorized($paramFetcher->get('smsAuthorized'));
                $ip = $request->getClientIp();
                $customer->setCreatedIp($ip);
                $customer->setUpdatedIp('');
                $customer->setCreatedUser(0);
                $customer->setUpdatedUser(0);
                $customer->setIndicator('S');
                $em = $this->getDoctrine()->getManager();
                $em->persist($customer);
                $customerPdv = new CustomerPdv();
                $customerPdv->setCustomer($customer);
                $customerPdv->setPdv($pdv);
                $customerPdv->setComment($paramFetcher->get('comment'));
                $em->persist($customerPdv);
                $em->flush();
                $password = $this->addUser($paramFetcher->get('lastname'), $paramFetcher->get('email'), $customerPdv);
                return new JsonResponse([
                    'password' => $password,
                    'id' => $customer->getId(),
                    'success' => true,
                    'code' => 200
                ]);
        }else{
            return new JsonResponse([],409);
        }

    }

    /**
     * @Rest\Put("/webSiteUsers/info/update")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="firstname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="lastname", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="phone", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="email", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="oldPassword", nullable=true,allowBlank=true,strict=true)
     */
    public function updateInfo(Request $request, ParamFetcher $paramFetcher)
    {
        $authorisation = $request->headers->get('Authorization');
        if ($authorisation && count(explode(" ", $authorisation)) == 2) {
            $token = explode(" ", $authorisation)[1];
            $em = $this->getDoctrine()->getManager();
            $qb = $em->createQueryBuilder();
            try {
                $id = JWT::decode($token, 'devfood', array('HS256'))->id;
                $password = $this->dec_enc('encrypt', $paramFetcher->get('oldPassword'));
                $user = $qb->select("c.id as customer")
                    ->from("RestocallBundle:webSiteUsers", "u")
                    ->innerJoin('u.customer', 'cp')
                    ->innerJoin('cp.customer', 'c')
                    ->where('u.id = :user')
                    ->andWhere('u.password=:password')
                    ->setParameter('user', $id)
                    ->setParameter('password', $password)
                    ->getQuery()->getResult(Query::HYDRATE_ARRAY);
                if (count($user) > 0) {
                    $customer = $this->getDoctrine()->getRepository("RestocallBundle:Customer")->find($user[0]['customer']);
                    $customer->setFirstname($paramFetcher->get('firstname'));
                    $customer->setLastname($paramFetcher->get('lastname'));
                    $customer->setPhone($paramFetcher->get('phone'));
                    $customer->setEmail($paramFetcher->get('email'));
                    $ip = $request->getClientIp();
                    $customer->setUpdatedIp($ip);
                    $customer->setUpdatedUser(0);
                    $em = $this->getDoctrine()->getManager();
                    $em->persist($customer);
                    $em->flush();
                    return new JsonResponse([
                        'success' => true,
                        'code' => 200
                    ]);
                } else {
                    return new JsonResponse([], 400);
                }
            } catch (\Exception $e) {
                return new JsonResponse([], 401);
            }
        } else {
            return new JsonResponse([], 401);
        }
    }


    /**
     * @Rest\Put("/webSiteUsers/updatePassword")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="password", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="oldPassword", nullable=true,allowBlank=true,strict=true)
     */
    public function updatePassword(Request $request, ParamFetcher $paramFetcher)
    {
        $authorisation = $request->headers->get('Authorization');
        if ($authorisation && count(explode(" ", $authorisation)) == 2) {
            $token = explode(" ", $authorisation)[1];
            $em = $this->getDoctrine()->getManager();
            $qb = $em->createQueryBuilder();
            try {
                $password = $this->dec_enc('encrypt', $paramFetcher->get('oldPassword'));
                $id = JWT::decode($token, 'devfood', array('HS256'))->id;
                $user = $qb->select("u")
                    ->from("RestocallBundle:webSiteUsers", "u")
                    ->where('u.id = :user')
                    ->andWhere('u.password=:password')
                    ->setParameter('user', $id)
                    ->setParameter('password', $password)
                    ->getQuery()->getResult(Query::HYDRATE_ARRAY);
                if (count($user) > 0) {
                    $user = $this->getDoctrine()->getRepository("RestocallBundle:webSiteUsers")->find($id);
                    $newPassword = $this->dec_enc('encrypt', $paramFetcher->get('password'));
                    $user->setPassword($newPassword);
                    $em->persist($user);
                    $em->flush();
                    return new JsonResponse([
                        'success' => true,
                        'code' => 200
                    ]);
                } else {
                    return new JsonResponse([], 400);
                }

            } catch (\Exception $e) {
                return new JsonResponse([], 401);
            }
        } else {
            return new JsonResponse([], 401);
        }
    }

    /**
     * @Rest\Post("/webSiteUsers/login")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="email", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="password", nullable=false,allowBlank=false,strict=true)
     * @RequestParam(name="pdv", nullable=false,allowBlank=false,strict=true)
     */

    public function login(ParamFetcher $paramFetcher)
    {
        $password = $this->dec_enc('encrypt', $paramFetcher->get('password'));
        $em = $this->getDoctrine()->getManager();
        $qb = $em->createQueryBuilder();
        $user = $qb->select("u.id,cp.id as customer")
            ->from("RestocallBundle:webSiteUsers", "u")
            ->innerJoin('u.customer', 'cp')
            ->innerJoin('cp.customer', 'c')
            ->innerJoin('cp.pdv', 'p')
            ->where('u.email = :email')
            ->andWhere('u.password = :password')
            ->andWhere('p.id = :pdv')
            ->andWhere('c.indicator = :indicator')
            ->setParameter('email', $paramFetcher->get('email'))
            ->setParameter('pdv', $paramFetcher->get('pdv'))
            ->setParameter('password', $password)
            ->setParameter('indicator', 'S')
            ->getQuery()->getResult(Query::HYDRATE_ARRAY);
        if (count($user) > 0) {
            $jwt = JWT::encode($user[0], 'devfood');
            return new JsonResponse([
                'token' => $jwt,
                'success' => true,
                'code' => 200
            ]);
        } else {
            return new JsonResponse([], 401);
        }
    }

    /**
     * @Rest\Get("/webSiteUsers/info")
     */

    public function getInfo(Request $request)
    {
        $authorisation = $request->headers->get('Authorization');
        if ($authorisation && count(explode(" ", $authorisation)) == 2) {
            $token = explode(" ", $authorisation)[1];
            $em = $this->getDoctrine()->getManager();
            $qb = $em->createQueryBuilder();
            try {
                $idUser = JWT::decode($token, 'devfood', array('HS256'))->id;
                $user = $qb->select("c.email, c.firstname, c.lastname, c.phone")
                    ->from("RestocallBundle:webSiteUsers", "u")
                    ->innerJoin('u.customer', 'cp')
                    ->innerJoin('cp.customer', 'c')
                    ->where('u.id = :user')
                    ->setParameter('user', $idUser)
                    ->getQuery()->getResult();
                $serializer = $this->get('serializer');
                $data = $serializer->serialize($user, 'json');
                return new JsonResponse(json_decode($data));
            } catch (\Exception $e) {
                return new JsonResponse([], 401);
            }
        } else {
            return new JsonResponse([], 401);
        }
    }


    /**
     * @Rest\Post("/webSiteUsers/address/add")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="streetName", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="streetNumber", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="postalCode", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="city", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="complementAddress", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="address", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="inputCode", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="building", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="staircase", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="floor", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="intercom", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="door", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="country", nullable=true,allowBlank=true,strict=true)
     */

    public function addAddress(Request $request, ParamFetcher $paramFetcher)
    {
        $authorisation = $request->headers->get('Authorization');
        if ($authorisation && count(explode(" ", $authorisation)) == 2) {
            $token = explode(" ", $authorisation)[1];
            $em = $this->getDoctrine()->getManager();
            $idUser = JWT::decode($token, 'devfood', array('HS256'))->id;
            $user = $this->getDoctrine()->getRepository("RestocallBundle:webSiteUsers")->find($idUser);
            $address = new Address();
            $address->setStreetName($paramFetcher->get('streetName'));
            $address->setStreetNumber($paramFetcher->get('streetNumber'));
            $address->setPostalCode($paramFetcher->get('postalCode'));
            $address->setCity($paramFetcher->get('city'));
            $address->setComplementAddress($paramFetcher->get('complementAddress'));
            $address->setInputCode($paramFetcher->get('inputCode'));
            $address->setBuilding($paramFetcher->get('building'));
            $address->setStaircase($paramFetcher->get('staircase'));
            $address->setFloor($paramFetcher->get('floor'));
            $address->setIntercom($paramFetcher->get('intercom'));
            $address->setDoor($paramFetcher->get('door'));
            $address->setCountry($paramFetcher->get('country'));
            $address->setCustomer($user->getCustomer());
            $em->persist($address);
            $em->flush();
            return new JsonResponse([
                'id' => $address->getId(),
                'success' => true,
                'code' => 200
            ]);
        } else {
            return new JsonResponse([], 401);
        }
    }

    /**
     * @Rest\Put("/webSiteUsers/address/update")
     * @param ParamFetcher $paramFetcher Paramfetcher
     * @RequestParam(name="streetName", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="streetNumber", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="postalCode", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="city", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="complementAddress", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="address", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="inputCode", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="building", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="staircase", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="floor", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="intercom", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="door", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="country", nullable=true,allowBlank=true,strict=true)
     * @RequestParam(name="id", nullable=true,allowBlank=true,strict=true)
     */

    public function updateAddress(Request $request, ParamFetcher $paramFetcher)
    {
        $authorisation = $request->headers->get('Authorization');
        if ($authorisation && count(explode(" ", $authorisation)) == 2) {
            $token = explode(" ", $authorisation)[1];
            $em = $this->getDoctrine()->getManager();
            $address = $this->getDoctrine()->getRepository("RestocallBundle:Address")->find($paramFetcher->get('id'));
            $address->setStreetName($paramFetcher->get('streetName'));
            $address->setStreetNumber($paramFetcher->get('streetNumber'));
            $address->setPostalCode($paramFetcher->get('postalCode'));
            $address->setCity($paramFetcher->get('city'));
            $address->setComplementAddress($paramFetcher->get('complementAddress'));
            $address->setInputCode($paramFetcher->get('inputCode'));
            $address->setBuilding($paramFetcher->get('building'));
            $address->setStaircase($paramFetcher->get('staircase'));
            $address->setFloor($paramFetcher->get('floor'));
            $address->setIntercom($paramFetcher->get('intercom'));
            $address->setDoor($paramFetcher->get('door'));
            $address->setCountry($paramFetcher->get('country'));
            $em->persist($address);
            $em->flush();
            return new JsonResponse([
                'success' => true,
                'code' => 200
            ]);
        } else {
            return new JsonResponse([], 401);
        }
    }

    /**
     * @Rest\Get("/webSiteUsers/address")
     */

    public function getAddress(Request $request)
    {
        $authorisation = $request->headers->get('Authorization');
        if ($authorisation && count(explode(" ", $authorisation)) == 2) {
            $token = explode(" ", $authorisation)[1];
            $em = $this->getDoctrine()->getManager();
            $qb1 = $em->createQueryBuilder();
            $customer = JWT::decode($token, 'devfood', array('HS256'))->customer;
            $address = $qb1->select("a")
                ->from("RestocallBundle:Address", "a")
                ->innerJoin('a.customer', 'cp')
                ->where('cp.id = :customer')
                ->setParameter('customer', $customer)
                ->getQuery()->getResult();
            $serializer = $this->get('serializer');
            $data = $serializer->serialize($address, 'json');
            return new JsonResponse(json_decode($data));

        } else {
            return new JsonResponse([], 401);

        }
    }


    /**
     * @Rest\Delete("/webSiteUsers/address/delete/{id}")
     */
    public function deleteAddress($id)
    {
        $em = $this->getDoctrine()->getManager();
        $a = $em->getRepository('RestocallBundle:Address')->find($id);
        $em->remove($a);
        $em->flush();
        return new JsonResponse([
            'success' => true,
            'code' => 200
        ]);
    }

    function dec_enc($action, $string)
    {
        $output = false;
        $encrypt_method = "AES-256-CBC";
        $secret_key = 'helpyfood';
        $secret_iv = 'helpyfood';
        $key = hash('sha256', $secret_key);
        $iv = substr(hash('sha256', $secret_iv), 0, 16);
        if ($action == 'encrypt') {
            $output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
            $output = base64_encode($output);
        } else if ($action == 'decrypt') {
            $output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
        }
        return $output;
    }
}



