<?php

namespace App\Controller;
ini_set('MAX_EXECUTION_TIME', -1);
set_time_limit(99999999999);

use App\Entity\Card;
use App\Entity\CardFamily;
use App\Entity\CardMenuCategory;
use App\Entity\CardOffer;
use App\Entity\Element;
use App\Entity\ElementOrderType;
use App\Entity\ElementSize;
use App\Entity\Ingredient;
use App\Entity\IngredientCatFamSize;
use App\Entity\Menu;
use App\Entity\MenuElementSize;
use App\Entity\MenuDay;
use App\Entity\MenuFamilySize;
use App\Entity\MenuOption;
use App\Entity\MenuOrderType;
use App\Entity\Size;
use Doctrine\ORM\EntityManagerInterface;
use FOS\RestBundle\Controller\FOSRestController;
use FOS\RestBundle\Controller\Annotations\Route;
use FOS\RestBundle\Controller\Annotations as Rest;
use FOS\RestBundle\Request\ParamFetcher;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;

class importCarteController extends Controller
{  
    private $idCarte1;
    private $idCarte2;
    private $pdv2;
    private $card2;
    private $em;
    private $mysqli;

    public function __construct(EntityManagerInterface $em)
    {
        $this->mysqli = new \mysqli("51.68.40.207", "root", "KkqJv6FkkZ", "restocallv1");
        $this->mysqli->set_charset('utf8');
        $this->em = $em;
    }

    /**
     * @Rest\Get("/copycarte/{idCarte1}/{idCarte2}")
     */
    public function import($idCarte1,$idCarte2)
    {
        $this->idCarte1 = $idCarte1;
        $this->idCarte2 = $idCarte2;
        $this->card2 = $this->em->getRepository('App:Card')->find(intval($this->idCarte2));
        $this->importCarte();
        return new JsonResponse(['test'], 200);
    }

    private function importCarte()
    {
        $query = "select * from card where id=" . $this->idCarte1;
        $statement = $this->mysqli->query($query);
        if ($statement->num_rows > 0) {
            $row = $statement->fetch_assoc();
            $started = new \DateTime($row['started_validity']);
            $stoped = new \DateTime($row['stopped_validity']);
            $this->card2->setStartedValidity($started);
            $this->card2->setStoppedValidity($stoped);
            $this->card2->setNbrOffersAuthorized($row['nbr_offers_authorized']);
            $this->card2->setNbrOffersAuthorizedSite($row['nbr_offers_authorized_site']);
            $this->card2->setDisplayCode($row['display_code']);
            $this->card2->setComment($row['comment']);
            $this->card2->setDeliveryCharges($row['delivery_charges']);
            $this->card2->setManagementFees($row['management_fees']);
            $this->em->persist($this->card2);
            $this->em->flush();
        }
        $this->importFamilies();
    }

    private function importFamilies(){
            $query1 = "select family_id from card_family where card_id=" . $this->idCarte1;
            $statement1 = $this->mysqli->query($query1);
            if ($statement1->num_rows > 0) {
                while ($row1 = $statement1->fetch_assoc()) {
                    $cardFamily = new CardFamily();
                    $family = $this->em->getRepository('App:Family')->find(intval($row1['family_id']));
                    $cardFamily->setCard($this->card2);
                    $cardFamily->setFamily($family);
                    // $cardFamily->setActive(1);
                    $this->em->persist($cardFamily);
                }
            }
            $query2 = "select menu_category_id from card_menu_category where card_id=" . $this->idCarte1;
            $statement2 = $this->mysqli->query($query2);
            if ($statement2->num_rows > 0) {
                    while ($row2 = $statement2->fetch_assoc()) {
                        $menuCategory = $this->em->getRepository('App:MenuCategory')->find(intval($row2['menu_category_id']));
                        $cardMenuCategory = new CardMenuCategory();
                        $cardMenuCategory->setMenuCategory($menuCategory);
                        $cardMenuCategory->setCard($this->card2);
                        $this->em->persist($cardMenuCategory);
                    }
            }
            $query3 = "select offer_id from card_offer where card_id=" . $this->idCarte1;
            $statement3 = $this->mysqli->query($query3);
            if ($statement3->num_rows > 0) {
                    while ($row3 = $statement3->fetch_assoc()) {
                        $offer = $this->getDoctrine()->getRepository("App:Offer")->find($row3['offer_id']);
                        $cardOffer = new CardOffer();
                        $cardOffer->setCard($this->card2);
                        $cardOffer->setOffer($offer);
                        $this->em->persist($cardOffer);
                    }
            }
            $this->em->flush();
            $this->importIngredients();
    }

    private function importIngredients()
    {

        $query = "select * from ingredient where card_id=" . $this->idCarte1;
        $statement = $this->mysqli->query($query);
        $card = $this->card2;
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $ingredient = new Ingredient();
                $categoryIng = $this->em->getRepository('App:IngredientCategory')->find(intval($row['ingredient_category_id']));
                $DATEENR = new \DateTime($row['created_at']);
                $DATELASTMOD = new \DateTime($row['updated_at']);
                $ingredient->setCard($card);
                $ingredient->setIngredientCategory($categoryIng);
                $ingredient->setName($row['name']);
                $ingredient->setAvailable($row['available']);
                $ingredient->setDescription($row['description']);
                $ingredient->setCreatedAt($DATEENR);
                $ingredient->setUpdatedAt($DATELASTMOD);
                $ingredient->setCreatedIp($row['created_ip']);
                $ingredient->setUpdatedIp($row['updated_ip']);
                $ingredient->setCreatedUser($row['created_user']);
                $ingredient->setUpdatedUser($row['updated_user']);
                $ingredient->setPrice($row['price']);
                $ingredient->setActiveSite(1);
                $ingredient->setFamilies([]);
                $ingredient->setIdOrigine($row['id']);
                $this->em->persist($ingredient);
            }
        }
        $this->em->flush();
        $this->importSizes();
    }

    private function importSizes(){
        $query = "select * from size where card_id=" . $this->idCarte1;
        $statement = $this->mysqli->query($query);
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $size = new Size();
                $card = $this->card2;
                $size->setCard($card);
                $size->setLabel($row['label']);
                $size->setLevel($row['level']);
                $size->setIdOrigine($row['id']);
                $query1 = "select cf.family_id from size_card_family sc,card_family cf where sc.card_family_id=cf.id and sc.size_id=" . $row['id'];
                $statement1 = $this->mysqli->query($query1);
                if ($statement1->num_rows > 0) {
                    while ($row1 = $statement1->fetch_assoc()) {
                        $qb = $this->em->createQueryBuilder();
                        $cardFamily = $qb->select("cf")
                            ->from("App:CardFamily", "cf")
                            ->innerJoin('cf.family', 'f')
                            ->innerJoin('cf.card', 'c')
                            ->where('f.id = :fam')
                            ->andWhere('c.id = :card')
                            ->setParameter('fam', $row1['family_id'])
                            ->setParameter('card', $this->idCarte2)
                            ->setMaxResults(1)
                            ->getQuery()->getOneOrNullResult();
                        if (!is_null($cardFamily))
                            $size->addFamily($cardFamily);
                    }
                }
                $this->em->persist($size);
                $this->em->flush();
            }
        }
        $this->importIngredientCatFamSize();
    }

    private function importIngredientCatFamSize()
    {
        $query = "select t.*,cf.family_id from ingredient_catFamSize as t, size as s,card_family cf where t.size_id = s.id AND t.`card_family_id`=cf.id and s.card_id=" . $this->idCarte1;
        $statement = $this->mysqli->query($query);
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $ingCatFamSize = new IngredientCatFamSize();
                $size = $this->em->getRepository('App:Size')->findOneBy(
                    array(
                        'idOrigine'=>intval($row['size_id']),
                        'card'=>$this->card2
                    )
                );
                $categoryIng = $this->em->getRepository('App:IngredientCategory')->find(intval($row['ingredient_category_id']));
                $ingCatFamSize->setSize($size);
                $ingCatFamSize->setIngredientCategory($categoryIng);
                $ingCatFamSize->setPrice($row['price']);
                $qb = $this->em->createQueryBuilder();
                $cardFamily = $qb->select("cf")
                    ->from("App:CardFamily", "cf")
                    ->innerJoin('cf.family', 'f')
                    ->innerJoin('cf.card', 'c')
                    ->where('f.id = :fam')
                    ->andWhere('c.id = :card')
                    ->setParameter('fam', $row['family_id'])
                    ->setParameter('card', $this->idCarte2)
                    ->setMaxResults(1)
                    ->getQuery()->getOneOrNullResult();
                $ingCatFamSize->setCardFamily($cardFamily);
                $this->em->persist($ingCatFamSize);
            }
            $this->em->flush();
        }
        $this->importElements();
    }

    private function importElements()
    {
        $query = "select e.*,cf.family_id as idFa from element e,card_family cf where e.family_id=cf.id and e.card_id=" . $this->idCarte1;
        $statement = $this->mysqli->query($query);
        $card = $this->card2;
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $element = new Element();
                $DATEENR = new \DateTime($row['created_at']);
                $DATELASTMOD = new \DateTime($row['updated_at']);
                $element->setCode($row['code']);
                $element->setName($row['name']);
                $element->setDescription($row['description']);
                $element->setAdditionalOption(1);
                $element->setActive($row['active']);
                $element->setHasSupp($row['hasSupp']);
                $element->setCustom(0);
                $element->setVat($row['vat']);
                $element->setMaxNbrIngOptions(intval($row['max_nbr_ing_options']));
                $element->setPriceSuppApp($row['price_supp_app']);
                $element->setCreatedUser($row['created_user']);
                $element->setCreatedIp($row['created_ip']);
                $element->setUpdatedIp($row['updated_ip']);
                $element->setUpdatedUser($row['updated_user']);
                $element->setCreatedAt($DATEENR);
                $element->setUpdatedAt($DATELASTMOD);
                $element->setActiveSite(1);
                // $time = $this->em->getRepository('App:Time')->find($row['element_time_id']);
                // $element->setElementTime($time);
                $element->setActiveSite(1);
                $element->setCard($card);
                $element->setIdOrigine($row['id']);
                // $element->setCustomPlatform(0);
                $qb = $this->em->createQueryBuilder();
                $cardFamily = $qb->select("cf")
                    ->from("App:CardFamily", "cf")
                    ->innerJoin('cf.family', 'f')
                    ->innerJoin('cf.card', 'c')
                    ->where('f.id = :fam')
                    ->andWhere('c.id = :card')
                    ->setParameter('fam', $row['idFa'])
                    ->setParameter('card', $this->idCarte2)
                    ->setMaxResults(1)
                    ->getQuery()->getOneOrNullResult();
                $element->setFamily($cardFamily);
                $query1 = "select ingredient_id from element_composition where element_id=" . $row['id'];
                $statement1 = $this->mysqli->query($query1);
                if ($statement1->num_rows > 0) {
                    while ($row1 = $statement1->fetch_assoc()) {
                        $composition = $this->em->getRepository('App:Ingredient')->findOneBy(
                            array(
                                'idOrigine'=>intval($row1['ingredient_id']),
                                'card'=>$card
                            )
                        );
                        if ($composition) {
                            $element->addElementComposition($composition);
                        }
                    }
                }
                $query2 = "select ingredient_id from element_option_ingredient where element_id=" . $row['id'];
                $statement2 = $this->mysqli->query($query2);
                if ($statement2->num_rows > 0) {
                    while ($row2 = $statement2->fetch_assoc()) {
                        $optionIngredient = $this->em->getRepository('App:Ingredient')->findOneBy(
                            array(
                                'idOrigine'=>intval($row2['ingredient_id']),
                                'card'=>$card
                            )
                        );
                        if ($optionIngredient) {
                            $element->addElementOption($optionIngredient);
                        }
                    }
                }
                $query3 = "select ingredient_id from element_supplement where element_id=" . $row['id'];
                $statement3 = $this->mysqli->query($query3);
                if ($statement3->num_rows > 0) {
                    while ($row3 = $statement3->fetch_assoc()) {
                        $supplement = $this->em->getRepository('App:Ingredient')->findOneBy(
                            array(
                                'idOrigine'=>intval($row3['ingredient_id']),
                                'card'=>$card
                            )
                        );
                        if ($supplement) {
                            $element->addElementSupplement($supplement);
                        }
                    }
                } else {
                    $element->setHasSupp(0);
                }
                $query4 = "select * from element_size where element_id=" . $row['id'];
                $statement4 = $this->mysqli->query($query4);
                if ($statement4->num_rows > 0) {
                    while ($row4 = $statement4->fetch_assoc()) {
                        $elementSize = new ElementSize();
                        $size = $this->em->getRepository('App:Size')->findOneBy(
                            array(
                                'idOrigine'=>intval($row4['size_id']),
                                'card'=>$card
                            )
                        );
                        if ($size) {
                            $elementSize->setSize($size);
                            $elementSize->setElement($element);
                            $elementSize->setAvailable($row4['available']);
                            $elementSize->setPriceSupp($row4['priceSupp']);
                            $elementSize->setPrice($row4['price']);
                            $this->em->persist($elementSize);
                        }
                    }
                }
                foreach ([1, 2, 3] as $tp) {
                    $query5 = "select * from element_order_mode where element_id=" . $row['id'] . " AND order_type_id=" . $tp;
                    $statement5 = $this->mysqli->query($query5);
                    if ($statement5->num_rows > 0) {
                        while ($row5 = $statement5->fetch_assoc()) {
                            $elementOrderType = new ElementOrderType();
                            $orderType = $this->em->getRepository('App:OrderType')->find(intval($tp));
                            $elementOrderType->setOrderType($orderType);
                            $elementOrderType->setElement($element);
                            $elementOrderType->setSupplement($row5['supplement']);
                            $elementOrderType->setActive($row5['actif']);
                            $this->em->persist($elementOrderType);
                        }
                    } else {
                        $elementOrderType = new ElementOrderType();
                        $orderType = $this->em->getRepository('App:OrderType')->find(intval($tp));
                        $elementOrderType->setOrderType($orderType);
                        $elementOrderType->setElement($element);
                        $elementOrderType->setSupplement(0);
                        $elementOrderType->setActive(0);
                        $this->em->persist($elementOrderType);
                    }
                }
                $this->em->persist($element);
            }
            $this->em->flush();
        }
        $this->importMenus();
    }

    private function importMenus()
    {
        //$query = "select * from menu where  card_id=" . $this->idCarte;
        $query="select m.*,cm.menu_category_id as idCa from menu m,card_menu_category cm where m.menu_category_id=cm.id and m.card_id=" . $this->idCarte1;
        $statement = $this->mysqli->query($query);
        $card = $this->card2;
        if ($statement->num_rows > 0) {
            while ($row = $statement->fetch_assoc()) {
                $menu = new Menu();
                $DATEENR = new \DateTime($row['created_at']);
                $DATELASTMOD = new \DateTime($row['updated_at']);
                $menu->setCode($row['code']);
                $menu->setTitle($row['title']);
                $menu->setPrice($row['price']);
                $menu->setVat($row['vat']);
                $menu->setDescription($row['description']);
                $menu->setAvailable($row['available']);
                $menu->setCreatedUser($row['created_user']);
                $menu->setCreatedIp($row['created_ip']);
                $menu->setUpdatedIp($row['updated_ip']);
                $menu->setUpdatedUser($row['updated_user']);
                $menu->setCreatedAt($DATEENR);
                $menu->setUpdatedAt($DATELASTMOD);
                $menu->setActiveSite(1);
                $menu->setVisible(1);
                $menu->setIdOrigine($row['id']);
                // $menuCategory = $this->em->getRepository('App:MenuCategory')->find(intval($row['menu_category_id']));
                $qb = $this->em->createQueryBuilder();
                $menuCategory = $qb->select("cm")
                ->from("App:CardMenuCategory", "cm")
                ->innerJoin('cm.menuCategory', 'ca')
                ->innerJoin('cm.card', 'c')
                ->where('ca.id = :ca')
                ->andWhere('c.id = :card')
                ->setParameter('ca', $row['idCa'])
                ->setParameter('card', $this->idCarte2)
                ->setMaxResults(1)
                ->getQuery()->getOneOrNullResult();

                $menu->setMenuCategory($menuCategory);
                $menuTime = $this->em->getRepository('App:Time')->find(intval($row['menu_time_id']));
                if (!is_null($menuTime)) {
                    $menu->setMenuTime($menuTime);
                }
                if (!is_null($card)) {
                    $menu->setCard($card);
                }
                if (intval($row['card_offer_id']) == 0) {
                    $menu->setOffer(null);
                } else {
                    $cardO = $this->em->getRepository('App:CardOffer')->find(intval($row['card_offer_id']));
                    $qb = $this->em->createQueryBuilder();
                    $offer = $qb->select("co")
                        ->from("App:CardOffer", "co")
                        ->innerJoin('co.offer', 'o')
                        ->innerJoin('co.card', 'c')
                        ->where('o.id = :offer')
                        ->andWhere('c.id = :card')
                        ->setParameter('offer', $cardO->getOffer()->getId())
                        ->setParameter('card', $this->idCarte2)
                        ->setMaxResults(1)
                        ->getQuery()->getOneOrNullResult();
                    if (!is_null($offer)) {
                        $menu->setOffer($offer);
                    }
                }
                foreach ([1, 2, 3] as $tp) {
                    $query5 = "select * from menu_order_mode where menu_id=" . $row['id'] . " AND order_type_id=" . $tp;
                    $statement5 = $this->mysqli->query($query5);
                    if ($statement5->num_rows > 0) {
                        while ($row5 = $statement5->fetch_assoc()) {
                            $menuOrderType = new MenuOrderType();
                            $orderType = $this->em->getRepository('App:OrderType')->find(intval($tp));
                            $menuOrderType->setOrderType($orderType);
                            $menuOrderType->setMenu($menu);
                            $menuOrderType->setSupplement($row5['supplement']);
                            $menuOrderType->setActive($row5['actif']);
                            $this->em->persist($menuOrderType);
                        }
                    }
                }
                $query2 = "select ms.*,es.element_id,es.size_id from menu_element_size ms,element_size es where ms.element_size_id=es.id and menu_id=" . $row['id'];
                $statement2 = $this->mysqli->query($query2);
                if ($statement2->num_rows > 0) {
                    while ($row2 = $statement2->fetch_assoc()) {
                        $qb0 = $this->em->createQueryBuilder();
                        $elementSize = $qb0->select("es")
                            ->from("App:ElementSize", "es")
                            ->innerJoin('es.size', 's')
                            ->innerJoin('s.card', 'sc')
                            ->innerJoin('es.element', 'e')
                            ->innerJoin('e.card', 'ec')
                            ->where('s.idOrigine = :size')
                            ->andWhere('sc.id = :card')
                            ->andWhere('e.idOrigine = :el')
                            ->andWhere('ec.id = :card')
                            ->setParameter('size', $row2['size_id'])
                            ->setParameter('el', $row2['element_id'])
                            ->setParameter('card', $this->idCarte2)
                            ->setMaxResults(1)
                            ->getQuery()->getOneOrNullResult();
                        if (!is_null($elementSize)) {
                            $menuElementSize = new MenuElementSize();
                            $menuElementSize->setMenu($menu);
                            $menuElementSize->setElementSize($elementSize);
                            $menuElementSize->setQuantity($row2['quantity']);
                            $menuElementSize->setChoice($row2['choice']);
                            $this->em->persist($menuElementSize);
                        }
                    }
                }

                $query3 = "select ms.*,cf.family_id from menu_family_size ms,card_family cf where cf.id=ms.card_family_id and menu_id=" . $row['id'];
                $statement3 = $this->mysqli->query($query3);
                if ($statement3->num_rows > 0) {
                    while ($row3 = $statement3->fetch_assoc()) {
                        $qb1 = $this->em->createQueryBuilder();
                        $cardFamily = $qb1->select("cf")
                            ->from("App:CardFamily", "cf")
                            ->innerJoin('cf.family', 'f')
                            ->innerJoin('cf.card', 'c')
                            ->where('f.id = :fam')
                            ->andWhere('c.id = :card')
                            ->setParameter('fam', $row3['family_id'])
                            ->setParameter('card', $this->idCarte2)
                            ->setMaxResults(1)
                            ->getQuery()->getOneOrNullResult();
                        $size = $this->em->getRepository('App:Size')->findOneBy(
                            array(
                                'idOrigine'=>intval($row3['size_id']),
                                'card'=>$this->card2
                            )
                        );
                        if (!is_null($cardFamily) && !is_null($size)) {
                            $menuFamilySize = new MenuFamilySize();
                            $menuFamilySize->setMenu($menu);
                            $menuFamilySize->setCardFamily($cardFamily);
                            $menuFamilySize->setSize($size);
                            $menuFamilySize->setQuantity($row3['quantity']);
                            $menuFamilySize->setChoice($row3['choice']);
                            $this->em->persist($menuFamilySize);
                        }
                    }
                }

                $query4 = "select me.*,es.element_id,es.size_id from menu_exclusion me,element_size es where me.element_size_id=es.id and me.menu_id=" . $row['id'];
                $statement4 = $this->mysqli->query($query4);
                if ($statement4->num_rows > 0) {
                    while ($row4 = $statement4->fetch_assoc()) {
                        $qb2 = $this->em->createQueryBuilder();
                        $elementSize = $qb2->select("es")
                            ->from("App:ElementSize", "es")
                            ->innerJoin('es.size', 's')
                            ->innerJoin('s.card', 'sc')
                            ->innerJoin('es.element', 'e')
                            ->innerJoin('e.card', 'ec')
                            ->where('s.idOrigine = :size')
                            ->andWhere('sc.id = :card')
                            ->andWhere('e.idOrigine = :el')
                            ->andWhere('ec.id = :card')
                            ->setParameter('size', $row2['size_id'])
                            ->setParameter('el', $row2['element_id'])
                            ->setParameter('card', $this->idCarte2)
                            ->setMaxResults(1)
                            ->getQuery()->getOneOrNullResult();
                        if (!is_null($elementSize)) {
                            $menu->addExcludedProduct($elementSize);
                        }
                    }
                }

                $query5 = "select mo.*,es.element_id,es.size_id from menu_option mo,element_size es where mo.element_size_id=es.id and mo.menu_id=" . $row['id'];
                $statement5 = $this->mysqli->query($query5);
                if ($statement5->num_rows > 0) {
                    while ($row5 = $statement5->fetch_assoc()) {
                        $qb3 = $this->em->createQueryBuilder();
                        $elementSize = $qb3->select("es")
                            ->from("App:ElementSize", "es")
                            ->innerJoin('es.size', 's')
                            ->innerJoin('s.card', 'sc')
                            ->innerJoin('es.element', 'e')
                            ->innerJoin('e.card', 'ec')
                            ->where('s.idOrigine = :size')
                            ->andWhere('sc.id = :card')
                            ->andWhere('e.idOrigine = :el')
                            ->andWhere('ec.id = :card')
                            ->setParameter('size', $row2['size_id'])
                            ->setParameter('el', $row2['element_id'])
                            ->setParameter('card', $this->idCarte2)
                            ->setMaxResults(1)
                            ->getQuery()->getOneOrNullResult();
                        if (!is_null($elementSize)) {
                            $menuOption = new MenuOption();
                            $menuOption->setMenu($menu);
                            $menuOption->setElementSize($elementSize);
                            $menuOption->setPrice($row5['price']);
                            $this->em->persist($menuOption);
                        }
                    }
                }

                $this->em->persist($menu);
            }
            $this->em->flush();
        }
        // $this->insertMenuDay();
    }

    // private function insertMenuDay()
    // {
    //     $sql = "select md.* from menu_day md,menu m where md.menu_id=m.id and m.card_id=". $this->idCarte1;
    //     $result = $this->mysqli->query($sql);
    //     if ($result->num_rows > 0) {
    //         while ($row = $result->fetch_assoc()) {
    //             $active=$row['active'];
    //             $idOrigin=$row['menu_id'];
    //             $qb = $this->em->createQueryBuilder();
    //             $day = $this->em->getRepository('App:Day')->find(intval($row['day_id']));
    //             $menu = $this->em->getRepository('App:Menu')->findOneBy(
    //                 array(
    //                     'idOrigine'=>intval($idOrigin),
    //                     'card'=>$this->card2
    //                 )
    //             );
    //             $menuDay = new MenuDay();
    //             $menuDay->setMenu($menu);
    //             $menuDay->setDay($day);
    //             $menuDay->setActive($active);
    //             $this->em->persist($menuDay);
    //         }
    //         $this->em->flush();
    //     }
    // }
}