<?php
/**
 * Created by PhpStorm.
 * User: PC
 * Date: 04/05/2018
 * Time: 16:26
 */

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;

/**
 * Address
 *
 * @ORM\Table(name="address")
 * @ORM\Entity
 * @ORM\HasLifecycleCallbacks
 */

class Address
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;


    /**
     * @var string
     *
     * @ORM\Column(name="street_number", type="string", length=7, nullable=true)
     */
    private $streetNumber;

    /**
     * @var string
     *
     * @ORM\Column(name="street_name", type="string", length=100, nullable=true)
     */
    private $streetName;

    /**
     * @var string
     *
     * @ORM\Column(name="postal_code", type="string", length=5, nullable=true)
     */
    private $postalCode;

    /**
     * @var string
     *
     * @ORM\Column(name="city", type="string", length=100, nullable=true)
     */
    private $city;

    /**
     * @var string
     *
     * @ORM\Column(name="complement_address", type="string", length=200, nullable=true)
     */
    private $complementAddress;

    /**
     * @var string
     *
     * @ORM\Column(name="input_code", type="string", length=20, nullable=true)
     */
    private $inputCode;

    /**
     * @var string
     *
     * @ORM\Column(name="building", type="string", length=20, nullable=true)
     */
    private $building;

    /**
     * @var string
     *
     * @ORM\Column(name="staircase", type="string", length=20, nullable=true)
     */
    private $staircase;

    /**
     * @var string
     *
     * @ORM\Column(name="floor", type="string", length=20, nullable=true)
     */
    private $floor;

    /**
     * @var string
     *
     * @ORM\Column(name="intercom", type="string", length=50, nullable=true)
     */
    private $intercom;

    /**
     * @var string
     *
     * @ORM\Column(name="door", type="string", length=20, nullable=true)
     */
    private $door;

    /**
     * @var string
     *
     * @ORM\Column(name="country", type="string", length=200, nullable=true)
     */
    private $country;

    /**
     * @ORM\ManyToOne(targetEntity="CustomerPdv")
     * @ORM\JoinColumn(name="customer_id", referencedColumnName="id", onDelete="cascade")
     */
    private $customer;

    /**
     * @var int
     *
     * @ORM\Column(name="principal", type="integer", nullable=true)
     */
    private $principal;

    /**
     * @var int
     *
     * @ORM\Column(name="active", type="integer", nullable=true)
     */
    private $active;


    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }


    /**
     * @return string
     */
    public function getStreetNumber()
    {
        return $this->streetNumber;
    }

    /**
     * @param string $streetNumber
     */
    public function setStreetNumber($streetNumber)
    {
        $this->streetNumber = $streetNumber;
    }

    /**
     * @return string
     */
    public function getStreetName()
    {
        return $this->streetName;
    }

    /**
     * @param string $streetName
     */
    public function setStreetName($streetName)
    {
        $this->streetName = $streetName;
    }

    /**
     * @return string
     */
    public function getPostalCode()
    {
        return $this->postalCode;
    }

    /**
     * @param string $postalCode
     */
    public function setPostalCode($postalCode)
    {
        $this->postalCode = $postalCode;
    }

    /**
     * @return string
     */
    public function getCity()
    {
        return $this->city;
    }

    /**
     * @param string $city
     */
    public function setCity($city)
    {
        $this->city = $city;
    }

    /**
     * @return string
     */
    public function getComplementAddress()
    {
        return $this->complementAddress;
    }

    /**
     * @param string $complementAddress
     */
    public function setComplementAddress($complementAddress)
    {
        $this->complementAddress = $complementAddress;
    }

    /**
     * @return string
     */
    public function getInputCode()
    {
        return $this->inputCode;
    }

    /**
     * @param string $inputCode
     */
    public function setInputCode($inputCode)
    {
        $this->inputCode = $inputCode;
    }

    /**
     * @return string
     */
    public function getBuilding()
    {
        return $this->building;
    }

    /**
     * @param string $building
     */
    public function setBuilding($building)
    {
        $this->building = $building;
    }

    /**
     * @return string
     */
    public function getStaircase()
    {
        return $this->staircase;
    }

    /**
     * @param string $staircase
     */
    public function setStaircase($staircase)
    {
        $this->staircase = $staircase;
    }

    /**
     * @return string
     */
    public function getFloor()
    {
        return $this->floor;
    }

    /**
     * @param string $floor
     */
    public function setFloor($floor)
    {
        $this->floor = $floor;
    }

    /**
     * @return string
     */
    public function getIntercom()
    {
        return $this->intercom;
    }

    /**
     * @param string $intercom
     */
    public function setIntercom($intercom)
    {
        $this->intercom = $intercom;
    }

    /**
     * @return string
     */
    public function getDoor()
    {
        return $this->door;
    }

    /**
     * @param string $door
     */
    public function setDoor($door)
    {
        $this->door = $door;
    }

    /**
     * @return string
     */
    public function getCountry()
    {
        return $this->country;
    }

    /**
     * @param string $country
     */
    public function setCountry($country)
    {
        $this->country = $country;
    }

    /**
     * @param mixed $customer
     */
    public function setCustomer($customer)
    {
        $this->customer = $customer;
    }

    /**
     * @return int
     */
    public function getPrincipal()
    {
        return $this->principal;
    }

    /**
     * @param int $principal
     */
    public function setPrincipal($principal)
    {
        $this->principal = $principal;
    }

    /**
     * @return int
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param int $active
     */
    public function setActive($active)
    {
        $this->active = $active;
    }

}