<?php
/**
 * Created by PhpStorm.
 * User: PC
 * Date: 11/06/2018
 * Time: 12:24
 */

namespace App\Entity;


use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * Bench
 *
 * @ORM\Table(name="bench")
 * @ORM\Entity
 */
class Bench
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var integer
     *
     * @ORM\Column(name="num", type="integer")
     */
    private $num;

    /**
     * @var integer
     *
     * @ORM\Column(name="nbr_person", type="integer")
     */
    private $nbrPerson;

    /**
     * @var string
     *
     * @ORM\Column(name="comment", type="string",length=200,nullable=true)
     */
    private $comment;

    /**
     * @ORM\ManyToOne(targetEntity="Pdv")
     * @ORM\JoinColumn(name="pdv_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $pdv;

    /**
     * @ORM\ManyToMany(targetEntity="Bench")
     * @ORM\JoinTable(name="bench_binding",
     *      joinColumns={@ORM\JoinColumn(name="benchInit_id", referencedColumnName="id", onDelete="cascade")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="benchSec_id", referencedColumnName="id", onDelete="cascade")}
     *      )
     */
    private $benchs;

    public function __construct()
    {
        $this->benchs = new ArrayCollection();
    }

    public function addBench(Bench $benchs)
    {
        $this->benchs[] = $benchs;
        return $this;
    }

    public function removeBench(Bench $benchs)
    {
        $this->benchs->removeElement($benchs);
    }

    /**
     * @return mixed
     */
    public function getBenchs()
    {
        $benchs=array();
        foreach ($this->benchs as $b){
            $benchs[]=Array('id'=>$b->getId(),'num'=>$b->getNum());
        }
        return $benchs;
    }

    /**
     * @param mixed $benchs
     */
    public function setBenchs($benchs)
    {
        $this->benchs = $benchs;
    }


    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId(int $id)
    {
        $this->id = $id;
    }

    /**
     * @return int
     */
    public function getNum()
    {
        return $this->num;
    }

    /**
     * @param int $num
     */
    public function setNum(int $num)
    {
        $this->num = $num;
    }

    /**
     * @return int
     */
    public function getNbrPerson()
    {
        return $this->nbrPerson;
    }

    /**
     * @param int $nbrPerson
     */
    public function setNbrPerson(int $nbrPerson)
    {
        $this->nbrPerson = $nbrPerson;
    }


    /**
     * @return string
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * @param string $comment
     */
    public function setComment(string $comment)
    {
        $this->comment = $comment;
    }


    /**
     * @param mixed $pdv
     */
    public function setPdv($pdv)
    {
        $this->pdv = $pdv;
    }


}
