<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * Card
 *
 * @ORM\Table(name="card_family")
 * @ORM\Entity
 */
class CardFamily
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="Card")
     * @ORM\JoinColumn(name="card_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $card;

    /**
     * @ORM\ManyToOne(targetEntity="Family")
     * @ORM\JoinColumn(name="family_id", referencedColumnName="id", nullable=false)
     */
    private $family;

    /**
     * @ORM\ManyToMany(targetEntity="Size", mappedBy="families",cascade={"remove"})
     */
    private $sizes;

    /**
     * @ORM\ManyToMany(targetEntity="Ingredient", mappedBy="families",cascade={"remove"})
     */
    private $ingredients;

	/**
     * @var integer
     *
     * @ORM\Column(name="level", type="integer", nullable=true)
     */
    private $order;

    /**
     * @ORM\OneToOne(targetEntity="Element", mappedBy="family", cascade={"remove"})
     */
    private $elements;



    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    /*public function getCard()
    {
        return $this->card;
    }*/

    /**
     * @param mixed $card
     */
    public function setCard($card)
    {
        $this->card = $card;
    }

    /**
     * @return mixed
     */
    public function getFamily()
    {
        return $this->family;
    }

    /**
     * @param mixed $family
     */
    public function setFamily($family)
    {
        $this->family = $family;
    }

    /**
     * @return int
     */
    public function getOrder()
    {
        return $this->order;
    }

    /**
     * @param int $order
     */
    public function setOrder($order)
    {
        $this->order = $order;
    }
}