<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * CardMenuCategory
 *
 * @ORM\Table(name="card_menu_category")
 * @ORM\Entity
 */
class CardMenuCategory
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="Card")
     * @ORM\JoinColumn(name="card_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $card;

    /**
     * @var integer
     *
     * @ORM\Column(name="level", type="integer", nullable=true)
     */
    private $order;

    /**
     * @ORM\ManyToOne(targetEntity="MenuCategory")
     * @ORM\JoinColumn(name="menu_category_id", referencedColumnName="id", nullable=false)
     */
    private $menuCategory;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */

    /**
     * @param mixed $card
     */
    public function setCard($card)
    {
        $this->card = $card;
    }

    /**
     * @return mixed
     */
    public function getMenuCategory()
    {
        return $this->menuCategory;
    }

    /**
     * @param mixed $menuCategory
     */
    public function setMenuCategory($menuCategory)
    {
        $this->menuCategory = $menuCategory;
    }





}