<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * CommandElementIngredients
 *
 * @ORM\Table(name="command_element_ingredients")
 * @ORM\Entity
 */
class CommandElementIngredients
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="action", type="string", length=10)
     */
    private $action;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=50)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="cout", type="decimal", precision=10, scale=2)
     */
    private $cout;

    /**
     * @ORM\ManyToOne(targetEntity="CommandElement" , inversedBy="command")
     * @ORM\JoinColumn(name="command_element_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $commandElement;

    /**
     * @var integer
     *
     * @ORM\Column(name="ingredient_id", type="integer", nullable=true)
     */
    private $ingredient;

    /**
     * Get id
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set action
     *
     * @param string $action
     *
     * @return CommandElementIngredients
     */
    public function setAction($action)
    {
        $this->action = $action;

        return $this;
    }

    /**
     * Get action
     *
     * @return string
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * Set name
     *
     * @param string $name
     *
     * @return CommandElementIngredients
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set cout
     *
     * @param string $cout
     *
     * @return CommandElementIngredients
     */
    public function setCout($cout)
    {
        $this->cout = $cout;

        return $this;
    }

    /**
     * Get cout
     *
     * @return string
     */
    public function getCout()
    {
        return $this->cout;
    }

    /**
     * @param mixed $commandElement
     */
    public function setCommandElement($commandElement)
    {
        $this->commandElement = $commandElement;
    }

    /**
     * @return mixed
     */
    public function getIngredient()
    {
        return $this->ingredient;
    }

    /**
     * @param mixed $ingredient
     */
    public function setIngredient($ingredient)
    {
        $this->ingredient = $ingredient;
    }

}

