<?php
/**
 * Created by PhpStorm.
 * User: PC
 * Date: 25/06/2018
 * Time: 13:55
 */
namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * CommandPaymentMode
 *
 * @ORM\Table(name="command_payment_mode")
 * @ORM\Entity
 */

class CommandPaymentMode
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     * @ORM\Column(name="amount",type="decimal", precision=10, scale=2)
     */
    private $amount;



    /**
     * @ORM\ManyToOne(targetEntity="Command", inversedBy="paymentMode")
     * @ORM\JoinColumn(name="command_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $command;

    /**
     * @ORM\ManyToOne(targetEntity="PaymentMode")
     * @ORM\JoinColumn(name="payment_mode_id", referencedColumnName="id")
     */
    private $paymentMode;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId(int $id)
    {
        $this->id = $id;
    }



    /**
     * @param mixed $command
     */
    public function setCommand($command)
    {
        $this->command = $command;
    }

    /**
     * @return mixed
     */
    public function getPaymentMode()
    {
        return $this->paymentMode;
    }

    /**
     * @param mixed $paymentMode
     */
    public function setPaymentMode($paymentMode)
    {
        $this->paymentMode = $paymentMode;
    }

    /**
     * @return string
     */
    public function getAmount()
    {
        return $this->amount;
    }

    /**
     * @param string $amount
     */
    public function setAmount(string $amount)
    {
        $this->amount = $amount;
    }



}

