<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 19/03/2018
 * Time: 18:06
 */

namespace App\Entity;
use Doctrine\ORM\Mapping as ORM;

/**
 * ElementOrderType
 *
 * @ORM\Table(name="element_order_mode")
 * @ORM\Entity
 */

class ElementOrderType
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var int
     * @ORM\Column(name="supplement", type="decimal", scale=2,precision= 10)
     */
    private $supplement;

    /**
     * @var boolean
     * @ORM\Column(name="actif", type="boolean")
     */
    private $active;

    /**
     * @ORM\ManyToOne(targetEntity="Element", inversedBy="elementOrderType")
     * @ORM\JoinColumn(name="element_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $element;

    /**
     * @ORM\ManyToOne(targetEntity="OrderType")
     * @ORM\JoinColumn(name="order_type_id", referencedColumnName="id")
     */
    private $orderType;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return int
     */
    public function getSupplement()
    {
        return $this->supplement;
    }

    /**
     * @param int $supplement
     */
    public function setSupplement($supplement)
    {
        $this->supplement = $supplement;
    }

    /**
     * @return mixed
     */
/*    public function getElement()
    {
        return $this->element;
    }*/

    /**
     * @param mixed $element
     */
    public function setElement($element)
    {
        $this->element = $element;
    }

    /**
     * @return mixed
     */
    public function getOrderType()
    {
        return $this->orderType;
    }

    /**
     * @param mixed $orderType
     */
    public function setOrderType($orderType)
    {
        $this->orderType = $orderType;
    }

    /**
     * @return bool
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param bool $active
     */
    public function setActive($active)
    {
        $this->active = $active;
    }
}