<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 19/03/2018
 * Time: 17:48
 */

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * ElementSize
 *
 * @ORM\Table(name="element_size")
 * @ORM\Entity
 */
class ElementSize
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var float
     * @ORM\Column(name="price", type="decimal", scale=2,precision= 10)
     */
    private $price;

    /**
     * @var boolean
     * @ORM\Column(name="available", type="boolean")
     */
    private $available;

    /**
     * @var int
     * @ORM\Column(name="priceSupp", type="decimal", scale=2,precision= 10)
     */
    private $priceSupp;


    /**
     * @ORM\ManyToOne(targetEntity="Element", inversedBy="elementSize")
     * @ORM\JoinColumn(name="element_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $element;

    /**
     * @ORM\ManyToOne(targetEntity="Size", inversedBy="elementSize")
     * @ORM\JoinColumn(name="size_id", referencedColumnName="id", onDelete="cascade")
     */
    private $size;

    /**
     * @ORM\OneToMany(targetEntity="MenuOption", mappedBy="elementSize", cascade={"remove"})
     */
    private $menuOptions;

    /**
     * @ORM\OneToMany(targetEntity="MenuElementSize", mappedBy="elementSize", cascade={"remove"})
     */
    private $menuElementSizes;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return int
     */
    public function getPrice()
    {
        return $this->price;
    }

    /**
     * @param int $price
     */
    public function setPrice($price)
    {
        $this->price = $price;
    }

    /**
     * @return int
     */
    public function getAvailable()
    {
        return $this->available;
    }

    /**
     * @param int $available
     */
    public function setAvailable($available)
    {
        $this->available = $available;
    }

    /**
     * @return int
     */
    public function getPriceSupp()
    {
        return $this->priceSupp;
    }

    /**
     * @param int $priceSupp
     */
    public function setPriceSupp($priceSupp)
    {
        $this->priceSupp = $priceSupp;
    }

    /**
     * @return mixed
     */
    // public function getElement()
    // {
    //     return $this->element;
    // }

    /**
     * @param mixed $element
     */
    public function setElement($element)
    {
        $this->element = $element;
    }

    /**
     * @return mixed
     */
    public function getSize()
    {
        return $this->size;
    }

    /**
     * @param mixed $size
     */
    public function setSize($size)
    {
        $this->size = $size;
    }



}