<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * IngredientCatFamSize
 *
 * @ORM\Table(name="ingredient_catFamSize")
 * @ORM\Entity
 */
class IngredientCatFamSize
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="Size")
     * @ORM\JoinColumn(name="size_id", referencedColumnName="id")
     */
    private $size;

    /**
     * @ORM\ManyToOne(targetEntity="IngredientCategory")
     * @ORM\JoinColumn(name="ingredient_category_id", referencedColumnName="id")
     */
    private $ingredientCategory;

    /**
     * @ORM\ManyToOne(targetEntity="CardFamily")
     * @ORM\JoinColumn(name="card_family_id", referencedColumnName="id" , onDelete="cascade")
     */
    private $cardFamily;
    /**
     * @var string
     *
     * @ORM\Column(name="price", type="decimal", precision=10, scale=2)
     */
    private $price;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getSize()
    {
        return $this->size;
    }

    /**
     * @param mixed $size
     */
    public function setSize($size)
    {
        $this->size = $size;
    }

    /**
     * @return mixed
     */
    public function getIngredientCategory()
    {
        return $this->ingredientCategory;
    }

    /**
     * @param mixed $ingredientCategory
     */
    public function setIngredientCategory($ingredientCategory)
    {
        $this->ingredientCategory = $ingredientCategory;
    }

    /**
     * @return mixed
     */
    public function getCardFamily()
    {
        return $this->cardFamily;
    }

    /**
     * @param mixed $cardFamily
     */
    public function setCardFamily($cardFamily)
    {
        $this->cardFamily = $cardFamily;
    }


    /**
     * @return string
     */
    public function getPrice()
    {
        return $this->price;
    }

    /**
     * @param string $price
     */
    public function setPrice($price)
    {
        $this->price = $price;
    }



}

