<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * LibraryIngredients
 *
 * @ORM\Table(name="library_ingredients")
 * @ORM\Entity
 */
class LibraryIngredients
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="IngredientCategory")
     * @ORM\JoinColumn(name="ingredient_category_id", referencedColumnName="id")
     */
    private $ingredientCategory;




    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=400, nullable=true)
     */


    private $name;



    /**
     * @var string
     *
     * @ORM\Column(name="description", type="string", length=400, nullable=true)
     */
    private $description;

    /**
     * @var string
     *
     * @ORM\Column(name="suggested_price", type="decimal", precision=10, scale=2, nullable=true)
     */
    private $suggestedPrice;

    /**
     * @var int
     *
     * @ORM\Column(name="active", type="integer", nullable=true)
     */
    private $active;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getIngredientCategory()
    {
        return $this->ingredientCategory;
    }

    /**
     * @param mixed $ingredientCategory
     */
    public function setIngredientCategory($ingredientCategory)
    {
        $this->ingredientCategory = $ingredientCategory;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * @return string
     */
    public function getSuggestedPrice()
    {
        return $this->suggestedPrice;
    }

    /**
     * @param string $suggestedPrice
     */
    public function setSuggestedPrice($suggestedPrice)
    {
        $this->suggestedPrice = $suggestedPrice;
    }

    /**
     * @return int
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param int $active
     */
    public function setActive($active)
    {
        $this->active = $active;
    }



}

