<?php
/**
 * Created by PhpStorm.
 * User: PC
 * Date: 02/08/2018
 * Time: 13:11
 */

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * LibrarySizes
 *
 * @ORM\Table(name="librarySizes")
 * @ORM\Entity
 */

class LibrarySizes
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;


    /**
     * @ORM\ManyToMany(targetEntity="Family", inversedBy="sizes",cascade={"persist"})
     * @ORM\JoinTable(name="size_family")
     */
    private $families;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=400, nullable=true)
     */

    private $name;

    /**
     * @var integer
     *
     * @ORM\Column(name="level", type="integer", length=400, nullable=true)
     */
    private $level;

    /**
     * @var integer
     *
     * @ORM\Column(name="active", type="integer", nullable=true)
     */
    private $active;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId(int $id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getFamilies()
    {
        return $this->families;
    }

    /**
     * @param mixed $families
     */
    public function setFamilies($families)
    {
        $this->families = $families;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName(string $name)
    {
        $this->name = $name;
    }

    /**
     * @return int
     */
    public function getLevel()
    {
        return $this->level;
    }

    /**
     * @param int $level
     */
    public function setLevel(int $level)
    {
        $this->level = $level;
    }

    /**
     * @return int
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param int $active
     */
    public function setActive(int $active)
    {
        $this->active = $active;
    }

    public function addFamily(Family $family)
    {
        $this->families[] = $family;
        return $this;
    }

    public function removeFamily(Family $family)
    {
        $this->families->removeElement($family);
    }




}