<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 14/02/2018
 * Time: 19:07
 */

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * MenuOption
 *
 * @ORM\Table(name="menu_option")
 * @ORM\Entity
 */
class MenuOption
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="Menu")
     * @ORM\JoinColumn(name="menu_id", referencedColumnName="id", nullable=false)
     */
    private $menu;

    /**
     * @ORM\ManyToOne(targetEntity="ElementSize")
     * @ORM\JoinColumn(name="element_size_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $elementSize;

    /**
     * @var float
     * @ORM\Column(name="price", type="decimal", scale=2,precision= 10)
     */
    private $price;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getMenu()
    {
        return $this->menu;
    }

    /**
     * @param mixed $menu
     */
    public function setMenu($menu)
    {
        $this->menu = $menu;
    }

    /**
     * @return mixed
     */
    public function getElementSize()
    {
        return $this->elementSize;
    }

    /**
     * @param mixed $elementSize
     */
    public function setElementSize($elementSize)
    {
        $this->elementSize = $elementSize;
    }

    /**
     * @return float
     */
    public function getPrice()
    {
        return $this->price;
    }

    /**
     * @param float $price
     */
    public function setPrice($price)
    {
        $this->price = $price;
    }

}