<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 15/02/2018
 * Time: 11:36
 */

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * OpeningDayPdv
 *
 * @ORM\Table(name="pdv_opening_day")
 * @ORM\Entity
 */
class OpeningDayPdv
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_start", type="datetime", nullable=true)
     */
    private $middayStart;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_start_site", type="datetime", nullable=true)
     */
    private $middayStartSite;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_end", type="datetime" , nullable=true)
     */
    private $middayEnd;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_end_site", type="datetime" , nullable=true)
     */
    private $middayEndSite;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_start", type="datetime" , nullable=true)
     */
    private $eveningStart;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_start_site", type="datetime" , nullable=true)
     */
    private $eveningStartSite;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_end", type="datetime" , nullable=true)
     */
    private $eveningEnd;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_end_site", type="datetime" , nullable=true)
     */
    private $eveningEndSite;


    /**
     * @ORM\ManyToOne(targetEntity="Pdv", inversedBy="openingDays", cascade={"remove"})
     * @ORM\JoinColumn(name="pdv_id", referencedColumnName="id", nullable=false)
     */
    private $pdv;

    /**
     * @ORM\ManyToOne(targetEntity="Day")
     * @ORM\JoinColumn(name="day_id", referencedColumnName="id" , nullable=false)
     */
    private $day;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return \DateTime
     */
    public function getMiddayStart()
    {
        return $this->middayStart;
    }

    /**
     * @param \DateTime $middayStart
     */
    public function setMiddayStart($middayStart)
    {
        $this->middayStart = $middayStart;
    }

    /**
     * @return \DateTime
     */
    public function getMiddayEnd()
    {
        return $this->middayEnd;
    }

    /**
     * @param \DateTime $middayEnd
     */
    public function setMiddayEnd($middayEnd)
    {
        $this->middayEnd = $middayEnd;
    }

    /**
     * @return \DateTime
     */
    public function getEveningStart()
    {
        return $this->eveningStart;
    }

    /**
     * @param \DateTime $eveningStart
     */
    public function setEveningStart($eveningStart)
    {
        $this->eveningStart = $eveningStart;
    }

    /**
     * @return \DateTime
     */
    public function getEveningEnd()
    {
        return $this->eveningEnd;
    }

    /**
     * @param \DateTime $eveningEnd
     */
    public function setEveningEnd($eveningEnd)
    {
        $this->eveningEnd = $eveningEnd;
    }

    /**
     * @return mixed
     */
    /*public function getPdv()
    {
        return $this->pdv;
    }*/

    /**
     * @param mixed $pdv
     */
    public function setPdv($pdv)
    {
        $this->pdv = $pdv;
    }

    /**
     * @return mixed
     */
    public function getDay()
    {
        return $this->day;
    }

    /**
     * @param mixed $day
     */
    public function setDay($day)
    {
        $this->day = $day;
    }
}