<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 14/02/2018
 * Time: 19:07
 */

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * OrderTypePdv
 *
 * @ORM\Table(name="pdv_order_type")
 * @ORM\Entity
 */
class OrderTypePdv
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var int
     * @ORM\Column(name="min_delay", type="integer")
     */
    private $minDelay;

    /**
     * @var int
     * @ORM\Column(name="max_delay", type="integer")
     */
    private $maxDelay;

    /**
     * @var int
     * @ORM\Column(name="default_min_delay", type="integer")
     */
    private $defaultMinDelay;

    /**
     * @var int
     * @ORM\Column(name="default_max_delay", type="integer")
     */
    private $defaultMaxDelay;

    /**
     * @var boolean
     * @ORM\Column(name="active", type="boolean")
     */
    private $active;

    /**
     * @ORM\ManyToOne(targetEntity="Pdv", inversedBy="citiesFrance")
     * @ORM\JoinColumn(name="pdv_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $pdv;

    /**
     * @ORM\ManyToOne(targetEntity="OrderType")
     * @ORM\JoinColumn(name="order_type_id", referencedColumnName="id")
     */
    private $orderType;

    /**
     * @ORM\OneToMany(targetEntity="OrderTypePdvDay", mappedBy="orderTypePdv", cascade={"remove","persist"})
     */
    private $availability;

    /**
     * @ORM\OneToMany(targetEntity="Command", mappedBy="orderTypePdv", cascade={"remove","persist"})
     */
    private $commands;

    public function __construct()
    {
        $this->availability = new ArrayCollection();
    }

    public function addOrderTypePdvDay(OrderTypePdvDay $orderTypePdvDay)
    {
        $this->availability[] = $orderTypePdvDay;
        return $this;
    }

    public function removeOrderTypePdvDay(OrderTypePdvDay $orderTypePdvDay)
    {
        $this->availability->removeElement($orderTypePdvDay);
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return int
     */
    public function getMinDelay()
    {
        return $this->minDelay;
    }

    /**
     * @param int $minDelay
     */
    public function setMinDelay($minDelay)
    {
        $this->minDelay = $minDelay;
    }

    /**
     * @return int
     */
    public function getMaxDelay()
    {
        return $this->maxDelay;
    }

    /**
     * @param int $maxDelay
     */
    public function setMaxDelay($maxDelay)
    {
        $this->maxDelay = $maxDelay;
    }

    /**
     * @return int
     */
    public function getDefaultMinDelay()
    {
        return $this->defaultMinDelay;
    }

    /**
     * @param int $defaultMinDelay
     */
    public function setDefaultMinDelay(int $defaultMinDelay)
    {
        $this->defaultMinDelay = $defaultMinDelay;
    }

    /**
     * @return int
     */
    public function getDefaultMaxDelay()
    {
        return $this->defaultMaxDelay;
    }

    /**
     * @param int $defaultMaxDelay
     */
    public function setDefaultMaxDelay(int $defaultMaxDelay)
    {
        $this->defaultMaxDelay = $defaultMaxDelay;
    }


    /**
     * @return mixed
     */
    /*public function getPdv()
    {
        return $this->pdv;
    }*/

    /**
     * @param mixed $pdv
     */
    public function setPdv($pdv)
    {
        $this->pdv = $pdv;
    }

    /**
     * @return mixed
     */
    public function getOrderType()
    {
        return $this->orderType;
    }

    /**
     * @param mixed $orderType
     */
    public function setOrderType($orderType)
    {
        $this->orderType = $orderType;
    }

    /**
     * @return mixed
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param bool $active
     */
    public function setActive($active)
    {
        $this->active = $active;
    }

    /**
     * @return mixed
     */
    public function getAvailability()
    {
        return $this->availability;
    }

    /**
     * @param mixed $availability
     */
    public function setAvailability($availability)
    {
        $this->availability = $availability;
    }
}