<?php
/**
 * Created by PhpStorm.
 * User: HP
 * Date: 15/02/2018
 * Time: 11:36
 */

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * OrderTypePdvDay
 *
 * @ORM\Table(name="pdv_order_type_day")
 * @ORM\Entity
 */
class OrderTypePdvDay
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_start", type="datetime", nullable=true)
     */
    private $middayStart;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_start_site", type="datetime", nullable=true)
     */
    private $middayStartSite;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_end", type="datetime" , nullable=true)
     */
    private $middayEnd;

    /**
     * @var \DateTime
     * @ORM\Column(name="midday_end_site", type="datetime" , nullable=true)
     */
    private $middayEndSite;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_start", type="datetime" , nullable=true)
     */
    private $eveningStart;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_start_site", type="datetime" , nullable=true)
     */
    private $eveningStartSite;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_end", type="datetime" , nullable=true)
     */
    private $eveningEnd;

    /**
     * @var \DateTime
     * @ORM\Column(name="evening_end_site", type="datetime" , nullable=true)
     */
    private $eveningEndSite;

    /**
     * @ORM\ManyToOne(targetEntity="OrderTypePdv", inversedBy="availability")
     * @ORM\JoinColumn(name="pdv_order_type_id", referencedColumnName="id", nullable=false, onDelete="cascade")
     */
    private $orderTypePdv;

    /**
     * @ORM\ManyToOne(targetEntity="Day")
     * @ORM\JoinColumn(name="day_id", referencedColumnName="id" , nullable=false)
     */
    private $day;

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return \DateTime
     */
    public function getMiddayStart()
    {
        $middayStart=($this->middayStart)?$this->middayStart->format('Y-m-d H:i:s'):null;
        return $middayStart;
    }

    /**
     * @return \DateTime
     */
    public function getMiddayStartSite()
    {
        $middayStartSite=($this->middayStartSite)?$this->middayStartSite->format('Y-m-d H:i:s'):null;
        return $middayStartSite;
    }

    /**
     * @param \DateTime $middayStart
     */
    public function setMiddayStart($middayStart)
    {

        $this->middayStart = $middayStart;
    }

    /**
     * @return \DateTime
     */
    public function getMiddayEnd()
    {
        $middayEnd=($this->middayEnd)?$this->middayEnd->format('Y-m-d H:i:s'):null;
        return $middayEnd;
    }

    /**
     * @return \DateTime
     */
    public function getMiddayEndSite()
    {
        $middayEndSite=($this->middayEndSite)?$this->middayEndSite->format('Y-m-d H:i:s'):null;
        return $middayEndSite;
    }

    /**
     * @param \DateTime $middayEnd
     */
    public function setMiddayEnd($middayEnd)
    {
        $this->middayEnd = $middayEnd;
    }

    /**
     * @return \DateTime
     */
    public function getEveningStart()
    {
        $eveningStart=($this->eveningStart)?$this->eveningStart->format('Y-m-d H:i:s'):null;
        return $eveningStart;
    }

     /**
     * @return \DateTime
     */
    public function getEveningStartSite()
    {
        $eveningStartSite=($this->eveningStartSite)?$this->eveningStartSite->format('Y-m-d H:i:s'):null;
        return $eveningStartSite;
    }

    /**
     * @param \DateTime $eveningStart
     */
    public function setEveningStart($eveningStart)
    {
        $this->eveningStart = $eveningStart;
    }

    /**
     * @return \DateTime
     */
    public function getEveningEnd()
    {
        $eveningEnd=($this->eveningEnd)?$this->eveningEnd->format('Y-m-d H:i:s'):null;
        return $eveningEnd;
    }

    /**
     * @return \DateTime
     */
    public function getEveningEndSite()
    {
        $eveningEndSite=($this->eveningEndSite)?$this->eveningEndSite->format('Y-m-d H:i:s'):null;
        return $eveningEndSite;
    }

    /**
     * @param \DateTime $eveningEnd
     */
    public function setEveningEnd($eveningEnd)
    {
        $this->eveningEnd = $eveningEnd;
    }

    /**
     * @param mixed $orderTypePdv
     */
    public function setOrderTypePdv($orderTypePdv)
    {
        $this->orderTypePdv = $orderTypePdv;
    }


    /**
     * @return mixed
     */
    public function getDay()
    {
        return $this->day;
    }

    /**
     * @param mixed $day
     */
    public function setDay($day)
    {
        $this->day = $day;
    }

    /**
     * @param \DateTime $middayStartSite
     */
    public function setMiddayStartSite($middayStartSite)
    {
        $this->middayStartSite = $middayStartSite;
    }

    /**
     * @param \DateTime $middayEndSite
     */
    public function setMiddayEndSite($middayEndSite)
    {
        $this->middayEndSite = $middayEndSite;
    }

    /**
     * @param \DateTime $eveningStartSite
     */
    public function setEveningStartSite($eveningStartSite)
    {
        $this->eveningStartSite = $eveningStartSite;
    }

    /**
     * @param \DateTime $eveningEndSite
     */
    public function setEveningEndSite($eveningEndSite)
    {
        $this->eveningEndSite = $eveningEndSite;
    }
}