<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use DateTime;
use JMS\Serializer\Annotation\Exclude;

/**
 * Pdv
 *
 * @ORM\Table(name="pdv")
 * @ORM\Entity
 * @ORM\HasLifecycleCallbacks
 */
class Pdv
{
    /**
     * @var int
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=400)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="siret", type="string", length=14)
     */
    private $siret;

    /**
     * @var string
     *
     * @ORM\Column(name="number", type="string", length=10)
     */
    private $number;

    /**
     * @var string
     *
     * @ORM\Column(name="address", type="string", length=400, nullable=true)
     */
    private $address;

    /**
     * @var string
     *
     * @ORM\Column(name="postal_code", type="string", length=5, nullable=true)
     */
    private $postalCode;

    /**
     * @var string
     *
     * @ORM\Column(name="city", type="string", length=100, nullable=true)
     */
    private $city;

    /**
     * @var string
     *
     * @ORM\Column(name="country", type="string", length=70, nullable=true)
     */
    private $country;

    /**
     * @var int
     *
     * @ORM\Column(name="reset_delay", type="integer")
     */
    private $resetDelay;

    /**
     * @var int
     *
     * @ORM\Column(name="close_site", type="integer")
     */
    private $closeSite;

    /**
     * @var text
     *
     * @ORM\Column(name="close_comment", type="text", nullable=true)
     */
    private $closeComment;

    /**
     * @var int
     *
     * @ORM\Column(name="displayBestSales", type="integer")
     */
    private $displayBestSales;

    /**
     * @var int
     *
     * @ORM\Column(name="displayBestOffers", type="integer")
     */
    private $displayBestOffers;

    /**
     * @var float
     *
     * @ORM\Column(name="amount_mini_order", type="float")
     */
    private $amountMiniOrder;

    /**
     * @var float
     *
     * @ORM\Column(name="amount_mini_society", type="float")
     */
    private $amountMiniSociety;

    /**
     * @var int
     *
     * @ORM\Column(name="amount_mini_mandatory", type="integer")
     */
    private $amountMiniMandatory;

    /**
     * @var string
     *
     * @ORM\Column(name="phone", type="string", length=10)
     */
    private $phone;

    /**
     * @var string
     *
     * @ORM\Column(name="email", type="string", length=100, nullable=true)
     */
    private $email;

    /**
     * @var int
     *
     * @ORM\Column(name="principal", type="integer")
     */
    private $principal;

    /**
     * @var int
     *
     * @ORM\Column(name="siteType", type="integer", nullable=true)
    */
    private $siteType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="active", type="boolean")
     */
    private $active;

    /**
     * @var float
     *
     * @ORM\Column(name="discount", type="float", nullable=true)
     */
    private $discount;

    /**
     * @var float
     * @ORM\Column(name="discount_from", type="decimal", scale=2,precision= 10, nullable=true)
     */
    private $discountFrom;

    /**
     * @var string
     *
     * @ORM\Column(name="image", type="string", length=250, nullable=true)
     */
    private $image;

    /**
     * @var text
     *
     * @ORM\Column(name="comment", type="text")
     */
    private $comment;

    /**
     * @var string
     *
     * @ORM\Column(name="email_contact", type="string", length=50, nullable=true)
     */
    private $emailContact;

    /**
     * @var string
     *
     * @ORM\Column(name="name_restaurant", type="string", length=255, nullable=true)
     */
    private $nameRestaurant;

    /**
     * @var string
     *
     * @ORM\Column(name="url_site", type="string", length=255, nullable=true)
     */
    private $urlSite;

    /**
     * @var string
     *
     * @ORM\Column(name="facebook", type="string", length=255, nullable=true)
     */
    private $facebook;

    /**
     * @var string
     *
     * @ORM\Column(name="phone_contact", type="string", length=255, nullable=true)
     */
    private $phoneContact;

    /**
     * @var int
     *
     * @ORM\Column(name="automatic_printing", type="integer")
     */
    private $automaticPrinting;

    /**
     * @var int
     *
     * @ORM\Column(name="automatic_printing2", type="integer", nullable=true)
     */
    private $automaticPrinting2;

    /**
     * @var string
     *
     * @ORM\Column(name="created_ip", type="string", length=50)
     */
    private $createdIp;

    /**
     * @var int
     *
     * @ORM\Column(name="created_user", type="integer")
     */
    private $createdUser;

    /**
     * @var string
     *
     * @ORM\Column(name="pdvKey", type="string", length=255)
     */
    private $pdvKey;

    /**
     * @var string
     *
     * @ORM\Column(name="updated_ip", type="string", length=50)
     */
    private $updatedIp;

    /**
     * @var int
     *
     * @ORM\Column(name="updated_user", type="integer")
     */
    private $updatedUser;

    /**
     * @var DateTime $created
     *
     * @ORM\Column(name="created_at", type="datetime", nullable=false)
     */
    protected $createdAt;
    /**
     * @var DateTime $updated
     *
     * @ORM\Column(name="updated_at", type="datetime", nullable=false)
     */
    protected $updatedAt;

    /**
     * @var string
     *
     * @ORM\Column(name="smtpemail", type="string", length=255, nullable=true)
     */
    private $smtpemail;

    /**
     * @var string
     *
     * @ORM\Column(name="smtppassword", type="string", length=255, nullable=true)
     */
    private $smtppassword;

    /**
     * @var int
     *
     * @ORM\Column(name="smtptype", type="integer", nullable=true, options={"default" : 1})
     */
    private $smtptype;

    /**
     * @ORM\PrePersist
     * @ORM\PreUpdate
     */
    public function updatedTimestamps()
    {
        $dateTimeNow = new DateTime('now');
        $this->setUpdatedAt($dateTimeNow);
        if ($this->getCreatedAt() === null) {
            $this->setCreatedAt($dateTimeNow);
        }
    }


    /**
     * @ORM\ManyToMany(targetEntity="PaymentMode", cascade={"persist"})
     * @ORM\JoinTable(name="pdv_payment_mode",
     *      inverseJoinColumns={@ORM\JoinColumn(name="payment_mode_id", referencedColumnName="id", onDelete="cascade")},
     *      joinColumns={@ORM\JoinColumn(name="pdv_id", referencedColumnName="id", onDelete="cascade")}
     *      )
     */
    private $paymentModes;

    /**
     * @ORM\ManyToOne(targetEntity="Restaurant", inversedBy="pdvs")
     * @ORM\JoinColumn(name="restaurant_id", referencedColumnName="id", nullable=false, onDelete="cascade"))
     * @Exclude
     */
    private $restaurant;

    /**
     * @ORM\OneToMany(targetEntity="CityFrancePdv", mappedBy="pdv", cascade={"persist","remove"})
     */
    private $citiesFrance;

    /**
     * @ORM\OneToMany(targetEntity="OpeningDayPdv", mappedBy="pdv", cascade={"remove"})
     */
    private $openingDays;

    /**
     * @ORM\OneToMany(targetEntity="OrderTypePdv", mappedBy="pdv", cascade={"persist","remove"})
     */
    private $orderTypes;

    /**
     * @ORM\OneToMany(targetEntity="CustomerPdv", mappedBy="pdv", cascade={"persist","remove"})
     */
    private $customers;

    /**
     * @ORM\OneToOne(targetEntity="Card", mappedBy="pdv", cascade={"persist","remove"})
     */
    private $card;

    /**
     * @var string
     *
     * @ORM\Column(name="printer", type="string", length=255, nullable=true)
     */
    private $printer;


    /**
     * Pdv constructor.
     */
    public function __construct()
    {
        $this->paymentModes = new ArrayCollection();
        $this->citiesFrance = new ArrayCollection();
        $this->openingDays = new ArrayCollection();
        $this->orderTypes = new ArrayCollection();
        /*$this->contacts= new ArrayCollection();*/
    }


    public function addPaymentMode(PaymentMode $payment_modes)
    {
        $this->paymentModes[] = $payment_modes;
        return $this;
    }

    public function removePaymentMode(PaymentMode $payment_modes)
    {
        $this->paymentModes->removeElement($payment_modes);
    }

   /* public function setContacts($contacts)
    {
        $this->contacts = $contacts;
    }*/

    public function addOrderType(OrderTypePdv $orderType)
    {
        $this->orderTypes[] = $orderType;
        return $this;
    }

    public function removeOrderType(OrderTypePdv $orderType)
    {
        $this->orderTypes->removeElement($orderType);
    }

    public function addCityFrance(CityFrancePdv $cityFrancePdv)
    {
        $this->citiesFrance[] = $cityFrancePdv;
        return $this;
    }

    public function removeCityFrance(CityFrancePdv $cityFrancePdv)
    {
        $this->citiesFrance->removeElement($cityFrancePdv);
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return string
     */
    public function getPrinter()
    {
        return $this->printer;
    }

    /**
     * @param string $printer
     */
    public function setPrinter($printer)
    {
        $this->printer = $printer;
    }

    /**
     * @return string
     */
    public function getSiret()
    {
        return $this->siret;
    }

    /**
     * @param string $siret
     */
    public function setSiret($siret)
    {
        $this->siret = $siret;
    }

    /**
     * @return string
     */
    public function getNumber()
    {
        return $this->number;
    }

    /**
     * @param string $number
     */
    public function setNumber($number)
    {
        $this->number = $number;
    }

    /**
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * @param string $address
     */
    public function setAddress($address)
    {
        $this->address = $address;
    }

    /**
     * @return string
     */
    public function getPostalCode()
    {
        return $this->postalCode;
    }

    /**
     * @param string $postalCode
     */
    public function setPostalCode($postalCode)
    {
        $this->postalCode = $postalCode;
    }

    /**
     * @return string
     */
    public function getCity()
    {
        return $this->city;
    }

    /**
     * @param string $city
     */
    public function setCity($city)
    {
        $this->city = $city;
    }

    /**
     * @return string
     */
    public function getCountry()
    {
        return $this->country;
    }

    /**
     * @param string $country
     */
    public function setCountry($country)
    {
        $this->country = $country;
    }

    /**
     * @return int
     */
    public function getResetDelay()
    {
        return $this->resetDelay;
    }

    /**
     * @param int $resetDelay
     */
    public function setResetDelay($resetDelay)
    {
        $this->resetDelay = $resetDelay;
    }

    /**
     * @return float
     */
    public function getAmountMiniOrder()
    {
        return $this->amountMiniOrder;
    }

    /**
     * @param float $amountMiniOrder
     */
    public function setAmountMiniOrder($amountMiniOrder)
    {
        $this->amountMiniOrder = $amountMiniOrder;
    }

    /**
     * @return float
     */
    public function getAmountMiniSociety()
    {
        return $this->amountMiniSociety;
    }

    /**
     * @param float $amountMiniSociety
     */
    public function setAmountMiniSociety($amountMiniSociety)
    {
        $this->amountMiniSociety = $amountMiniSociety;
    }

    /**
     * @return int
     */
    public function getAmountMiniMandatory()
    {
        return $this->amountMiniMandatory;
    }

    /**
     * @param int $amountMiniMandatory
     */
    public function setAmountMiniMandatory($amountMiniMandatory)
    {
        $this->amountMiniMandatory = $amountMiniMandatory;
    }

    /**
     * @return string
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * @param string $phone
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
    }

    /**
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * @param string $email
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }

    /**
     * @return int
     */
    public function getPrincipal()
    {
        return $this->principal;
    }

    /**
     * @param int $principal
     */
    public function setPrincipal($principal)
    {
        $this->principal = $principal;
    }

    /**
     * @return int
     */
    public function getSiteType()
    {
        return $this->siteType;
    }

    /**
     * @param int $siteType
     */
    public function setSiteType($siteType)
    {
        $this->siteType = $siteType;
    }

    /**
     * @return int
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * @param int $active
     */
    public function setActive($active)
    {
        $this->active = $active;
    }

    /**
     * @return int
     */
    public function getAutomaticPrinting()
    {
        return $this->automaticPrinting;
    }

    /**
     * @param int $automaticPrinting
     */
    public function setAutomaticPrinting($automaticPrinting)
    {
        $this->automaticPrinting = $automaticPrinting;
    }

    /**
     * @return int
     */
    public function getAutomaticPrinting2()
    {
        return $this->automaticPrinting2;
    }

    /**
     * @param int $automaticPrinting2
     */
    public function setAutomaticPrinting2($automaticPrinting2)
    {
        $this->automaticPrinting2 = $automaticPrinting2;
    }

    /**
     * @return string
     */
    public function getCreatedIp()
    {
        return $this->createdIp;
    }

    /**
     * @param string $createdIp
     */
    public function setCreatedIp($createdIp)
    {
        $this->createdIp = $createdIp;
    }

    /**
     * @return int
     */
    public function getCreatedUser()
    {
        return $this->createdUser;
    }

    /**
     * @param int $createdUser
     */
    public function setCreatedUser($createdUser)
    {
        $this->createdUser = $createdUser;
    }

    /**
     * @return string
     */
    public function getUpdatedIp()
    {
        return $this->updatedIp;
    }

    /**
     * @param string $updatedIp
     */
    public function setUpdatedIp($updatedIp)
    {
        $this->updatedIp = $updatedIp;
    }

    /**
     * @return int
     */
    public function getUpdatedUser()
    {
        return $this->updatedUser;
    }

    /**
     * @param int $updatedUser
     */
    public function setUpdatedUser($updatedUser)
    {
        $this->updatedUser = $updatedUser;
    }

    /**
     * @return DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * @param DateTime $createdAt
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;
    }

    /**
     * @return DateTime
     */
    public function getUpdatedAt()
    {
        return $this->updatedAt;
    }

    /**
     * @param DateTime $updatedAt
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;
    }

    /**
     * @return mixed
     */
    public function getPaymentModes()
    {
        return $this->paymentModes;
    }

    /**
     * @param mixed $paymentModes
     */
    public function setPaymentModes($paymentModes)
    {
        $this->paymentModes = $paymentModes;
    }

    /**
     * @return mixed
     */
    public function getRestaurant()
    {
        return $this->restaurant;
    }

    /**
     * @param mixed $restaurant
     */
    public function setRestaurant($restaurant)
    {
        $this->restaurant = $restaurant;
    }

    /**
     * @return mixed
     */
    public function getCitiesFrance()
    {
        return $this->citiesFrance;
    }

    /**
     * @param mixed $citiesFrance
     */
    public function setCitiesFrance($citiesFrance)
    {
        $this->citiesFrance = $citiesFrance;
    }

    /**
     * @return mixed
     */
    public function getOpeningDays()
    {
        return $this->openingDays;
    }

    /**
     * @param mixed $openingDays
     */
    public function setOpeningDays($openingDays)
    {
        $this->openingDays = $openingDays;
    }

    /**
     * @return mixed
     */
    public function getOrderTypes()
    {
        return $this->orderTypes;
    }

    /**
     * @param mixed $orderTypes
     */
    public function setOrderTypes($orderTypes)
    {
        $this->orderTypes = $orderTypes;
    }

    /**
     * @return mixed
     */
   /* public function getCard()
    {
        return $this->card;
    }*/

    /**
     * @param mixed $card
     */
    public function setCard($card)
    {
        $this->card = $card;
    }

    /**
     * @return string
     */
    public function getImage()
    {
        return $this->image;
    }

    /**
     * @param string $image
     */
    public function setImage($image)
    {
        $this->image = $image;
    }

    /**
     * @return text
     */
    public function getComment()
    {
        return $this->comment;
    }

    /**
     * @param text $comment
     */
    public function setComment($comment)
    {
        $this->comment = $comment;
    }

    /**
     * @return text
     */
    public function getCloseComment()
    {
        return $this->closeComment;
    }

    /**
     * @param text $closeComment
     */
    public function setCloseComment($closeComment)
    {
        $this->closeComment = $closeComment;
    }

    /**
     * @return string
     */
    public function getEmailContact()
    {
        return $this->emailContact;
    }

    /**
     * @param string $emailContact
     */
    public function setEmailContact($emailContact)
    {
        $this->emailContact = $emailContact;
    }

    /**
     * @return string
     */
    public function getPdvKey()
    {
        return $this->pdvKey;
    }

    /**
     * @param string $pdvKey
     */
    public function setPdvKey($pdvKey)
    {
        $this->pdvKey = $pdvKey;
    }

    /**
     * @return int
     */
    public function getCloseSite()
    {
        return $this->closeSite;
    }

    /**
     * @param int $closeSite
     */
    public function setCloseSite($closeSite)
    {
        $this->closeSite = $closeSite;
    }


    /**
     * @return int
     */
    public function getDisplayBestSales()
    {
        return $this->displayBestSales;
    }

    /**
     * @param int $displayBestSales
     */
    public function setDisplayBestSales($displayBestSales)
    {
        $this->displayBestSales = $displayBestSales;
    }


    /**
     * @return int
     */
    public function getDisplayBestOffers()
    {
        return $this->displayBestOffers;
    }

    /**
     * @param int $displayBestSales
     */
    public function setDDisplayBestOffers($displayBestOffers)
    {
        $this->displayBestOffers = $displayBestOffers;
    }


    /**
     * @return string
     */
    public function getNameRestaurant()
    {
        return $this->nameRestaurant;
    }

    /**
     * @param string $nameRestaurant
     */
    public function setNameRestaurant($nameRestaurant)
    {
        $this->nameRestaurant = $nameRestaurant;
    }

    /**
     * @return string
     */
    public function getUrlSite()
    {
        return $this->urlSite;
    }

    /**
     * @param string $urlSite
     */
    public function setUrlSite($urlSite)
    {
        $this->urlSite = $urlSite;
    }

    /**
     * @return string
     */
    public function getPhoneContact()
    {
        return $this->phoneContact;
    }

    /**
     * @param string $phoneContact
     */
    public function setPhoneContact($phoneContact)
    {
        $this->phoneContact = $phoneContact;
    }

    /**
     * @return string
     */
    public function getSmtpemail()
    {
        return $this->smtpemail;
    }

    /**
     * @param string $smtpemail
     */
    public function setSmtpemail(string $smtpemail)
    {
        $this->smtpemail = $smtpemail;
    }

    /**
     * @return string
     */
    public function getSmtppassword()
    {
        return $this->smtppassword;
    }

    /**
     * @param string $smtppassword
     */
    public function setSmtppassword($smtppassword)
    {
        $this->smtppassword = $smtppassword;
    }

    /**
     * @return string
     */
    public function getFacebook()
    {
        return $this->facebook;
    }

    /**
     * @param string $facebook
     */
    public function setFacebook($facebook)
    {
        $this->facebook = $facebook;
    }
}