<?php

namespace App\Repository;

/**
 * IngredientRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class IngredientRepository extends \Doctrine\ORM\EntityRepository
{
    public function getIngredientComposByEl($idElement,$card)
    {
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $compositions = $qb->select("ec.id,ec.avatar,ec.available,ec.name as text,ic.order,case when ec.available = 1 then 'false' else 'true' end as disabled")
            ->from("App:Element", "e")
            ->innerJoin('e.elementComposition', 'ec')
            ->innerJoin('ec.ingredientCategory', 'ic')
            ->where('e.id LIKE :element');
            if (!is_null($card)) {
                $compositions = $compositions->innerJoin('e.card', 'c')
                    ->andWhere('c.id=:card')->setParameter('card', $card);
            }
        $compositions = $compositions->setParameter('element', $idElement)
            ->getQuery()->getResult();
        return $compositions;
    }
    public function getSiteIngredientComposByEl($idElement,$card)
    {
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $compositions = $qb->select("ec.id,ec.avatar,ec.available,ec.name as text,ic.order,case when ec.available = 1 then 'false' else 'true' end as disabled")
            ->from("App:Element", "e")
            ->innerJoin('e.elementComposition', 'ec')
            ->innerJoin('ec.ingredientCategory', 'ic')
            ->where('e.id LIKE :element')
            ->andWhere('ec.activeSite=1')
            ->setParameter('element', $idElement)
            ->getQuery()->getResult();
        return $compositions;
    }
    public function hasSupp($idElement)
    {
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $compositions = $qb->select("ec.id,ec.avatar,ec.available,ec.name as text,case when ec.available = 1 then 'false' else 'true' end as disabled")
            ->from("App:Element", "e")
            ->innerJoin('e.elementComposition', 'ec')
            ->where('e.id LIKE :element')
            ->setParameter('element', $idElement)
            ->getQuery()->getResult();
        return $compositions;
    }
    public function has($idElement)
    {
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $compositions = $qb->select("ec.id,ec.avatar,ec.available,case when ec.available = 1 then 'false' else 'true' end as disabled,ec.name as text")
            ->from("App:Element", "e")
            ->innerJoin('e.elementComposition', 'ec')
            ->where('e.id LIKE :element')
            ->setParameter('element', $idElement)
            ->getQuery()->getResult();
        return $compositions;
    }
}
