var server     = require('http').createServer(),
    io         = require('socket.io')(server),
    logger     = require('winston'),
    port       = 1337;

io.set('heartbeat timeout', 60000);
io.set('heartbeat interval', 25000);
// Logger config
logger.remove(logger.transports.Console);
logger.add(logger.transports.Console, { colorize: true, timestamp: true });
logger.info('SocketIO > listening on port ' + port);

io.on('connection', function (socket){
    //var nb = 0;

    logger.info('SocketIO > Connected socket ' + socket.id);

    socket.on('notif', function (message) {
        //++nb;
        //logger.info('ElephantIO broadcast > ' + JSON.stringify(message));

        // send to all connected clients
        io.sockets.emit("notification", message);
    });

    socket.on('disconnect', function () {
        //logger.info('SocketIO : Received ' + nb + ' messages');
        logger.info('SocketIO > Disconnected socket ' + socket.id);
    });
});

server.listen(port);
